﻿/*
 * Declaration for the Guideline pseudo-namespace for Guideline display processing.
 */
var Guideline = function() {};

var countGuidelineItem = 1;

Guideline.initExpandGuideline = function()
{
  var query = location.search;
  if (query.lastIndexOf('?') != -1) query = query.slice(query.lastIndexOf('?') + 1);

  var params = query.split('&');
  var mode = Reassemble.viewMode;
  var level = '1';
  var figure = '1';
  var table = '1';
  var code = '1';
  var url = '';

  for (i = 0; i < params.length; i++)
  {
    var param = params[i];
    var ind = param.indexOf('=');
    if (ind < 0) continue;
    var key = param.substring(0, ind);
    key = decodeURIComponent(key);
    var data = decodeURIComponent(param.slice(ind + 1));
    if (key.match(/^mode$/i))
    {
      // mode = data;
    }
    else if (key.match(/^level$/i))
    {
      level = data;
    }
    else if (key.match(/^figure$/i))
    {
      figure = parseInt(data);
      if (isNaN(figure)) figure = 0;
    }
    else if (key.match(/^table$/i))
    {
      table = parseInt(data);
      if (isNaN(table)) table = 0;
    }
    else if (key.match(/^code$/i))
    {
      code = parseInt(data);
      if (isNaN(code)) code = 0;
    }
    else if (key.match(/^url$/i))
    {
      url = data;
    }
  }

  var nMode = parseInt(mode);
  if (isNaN(nMode)) nMode = 0;
  if ((nMode < 0) || (nMode > 2)) nMode = 0;
  $('div[id^=' + TemplateSettings.guidelineDescIdPrefix + ']').css('display', (((nMode == 0) || (nMode == 1)) ? 'block' : 'none'));
  $('div[id^=' + TemplateSettings.guidelineItemIdPrefix + ']').css('display', (((nMode == 0) || (nMode == 2)) ? 'block' : 'none'));
}

Guideline.viewPage = function(url, target, level, figure, table, code)
{
  var urls = url.split('#');
  var loc = urls[0] + '?level=' + level + '&figure=' + figure + '&table=' + table + '&code=' + code + ((urls.length > 1) ? ('#' + urls[1]) : (''));
  if ((target != null) && (target != ''))
  {
    // Transition to the current window for now.
    //window.open(loc, target);
    location.href = loc;
  }
  else
  {
    location.href = loc;
  }
}

