﻿/*---------------------------------------------------------------------------*
  Project:  Pia
  File:     Shared_Inet_Login.h

  Copyright (C) 2011-2014 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/

#ifndef SHARED_INET_LOGIN_H_
#define SHARED_INET_LOGIN_H_

#include "Shared_Inet_Common.h"
#include "Shared_Nex_Common.h"

#if NN_PIA_CTR

// Use existing server on WAN.
#define ENABLE_LAN_NETWORK 0

// Parameter to use for login.
#if NN_PIA_NEX_3
#if (NEX_CURRENT_VERSION_NUMBER >= NEX_VERSION_NUMBER(3,5,0))
#define MATCHMAKE_GAME_ID    0x1F900D00
#define MATCHMAKE_ACCESS_KEY _T("3c273382")
#else
#define MATCHMAKE_GAME_ID    0x1F900000
#define MATCHMAKE_ACCESS_KEY _T("3c273382")
#define MATCHMAKE_KEY_HASH   "deed2a88"
#endif
#else
#define MATCHMAKE_GAME_ID    0x0FE00301
#define MATCHMAKE_ACCESS_KEY _T("871b3169")
#define MATCHMAKE_KEY_HASH   "deed2a88"
#endif

#elif NN_PIA_WIN

// Set to 1 if using a server in the LAN.
#define ENABLE_LAN_NETWORK 1
// Parameters used for login
#define MATCHMAKE_GAME_ID    0x1f940000
#define MATCHMAKE_ACCESS_KEY _T("ab8db073")
#define MATCHMAKE_KEY_HASH   "deed2a88"

#elif NN_PIA_CAFE

// Use existing server on WAN.
#define ENABLE_LAN_NETWORK 0
// Parameter to use for login.
#if (NEX_CURRENT_VERSION_NUMBER >= NEX_VERSION_NUMBER(3,5,0))
#define MATCHMAKE_GAME_ID    0x1F900D00
#define MATCHMAKE_ACCESS_KEY _T("3c273382")
#else
#define MATCHMAKE_GAME_ID    0x1F900000
#define MATCHMAKE_ACCESS_KEY _T("3c273382")
#endif
#define MATCHMAKE_KEY_HASH   "deed2a88"

#endif


// Log into the game server
// Logs onto the friend server at the same time
nn::Result Inet_Login(
    nn::nex::NgsFacade* pNgsFacade,
    u32 gameId, 
    const qChar* pAccessKey,
    u32 timeout
);

// Logs out from game server
nn::Result Inet_Logout(nn::nex::NgsFacade* pNgsFacade);

nn::nex::PrincipalID Inet_GetOwnerPID();
void Inet_SetOwnerPID(nn::nex::PrincipalID id);
s32 Inet_GetLoginNetworkErrorCode();
void Inet_ResetLoginNetworkErrorCode();

#endif
