/*---------------------------------------------------------------------------*
  Project:  Pia
  File:     Shared_Inet_Matchmake.h

  Copyright (C)2011-2014 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/

#ifndef SHARED_INET_MATCHMAKE_H_
#define SHARED_INET_MATCHMAKE_H_

#include "Shared_Inet_Common.h"
#include "Shared_Nex_Common.h"

nn::Result Inet_AutoMatchmake(
    nn::nex::MatchmakeExtensionClient* pMatchMakingClient,
    nn::nex::GatheringID* pJoinedGatheringId,
    nn::nex::PrincipalID* pOwnerPID,
    u16 matchmakeMaxParticipants,
    u32 netMatchMode,
    const char* matchmakeDescription = NULL
);

nn::Result Inet_OpenParticipation(
    nn::nex::MatchmakeExtensionClient* pMatchMakingClient, 
    nn::nex::GatheringID gatheringID
);

nn::Result Inet_LeaveMatchmakeSession(
    nn::nex::MatchmakeExtensionClient* pMatchMakingClient, 
    nn::nex::GatheringID gatheringID,
    nn::nex::PrincipalID ownerPID,
    bool hostMigration
);

nn::Result Inet_GetHostStationURLs(
    nn::nex::MatchmakeExtensionClient* pMatchMakingClient,
    nn::nex::GatheringID joinedGatheringId,
    nn::nex::qList<nn::nex::StationURL>* pStationURLs
);

nn::Result Inet_SearchMatchmakeSession(
    nn::nex::MatchmakeExtensionClient* pMatchMakingClient,
    u32 gameMode, 
    u16 maxParticipants,
    u32 rangeSize,
    nn::nex::qList<nn::nex::GatheringHolder>* plistGatheringHolder
);

nn::Result Inet_CreateMatchmakeSession(
    nn::nex::MatchmakeExtensionClient* pMatchMakingClient,
    nn::nex::GatheringID* pJoinedGatheringID,
    u32 gameMode, 
    u16 maxParticipants,
    const char* description
);

nn::Result Inet_JoinMatchmakeSession(
    nn::nex::MatchmakeExtensionClient* pMatchMakingClient,
    nn::nex::GatheringID gatheringID
);

u32 Inet_GetMatchmakeNetworkErrorCode();
void Inet_ResetMatchmakeNetworkErrorCode();

nn::nex::qVector<nn::nex::qByte>* Inet_GetMatchmakeSessionSignatureKey();
nn::pia::common::SignatureSetting* Inet_GetMatchmakeSessionSignatureSetting();

#endif
