﻿/*---------------------------------------------------------------------------*
  Project:  Pia
  File:     Shared_Inet_NetSetup.h

  Copyright (C)2011-2014 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/

#ifndef SHARED_INET_NET_SETUP_H_
#define SHARED_INET_NET_SETUP_H_

#include "Shared_Inet_Common.h"

#if NN_PIA_CTR
#include <nn/version.h>
#include <nn/init.h>
#include <nn/os.h>
#include <nn/ac.h>
#if (NN_VERSION_MAJOR == 2 && NN_VERSION_MINOR == 4 && NN_VERSION_MICRO >= 1) || NN_VERSION_MAJOR >= 3
#include <nn/socket_Initialize.h>
#else
#include <nn/socket.h>
#endif
#elif NN_PIA_CAFE
#include <cafe/net/so.h>
#include <nn/ac.h>
#include <nn/act.h>
#include <nn/fp.h>
#endif

nn::Result Inet_InitializeNetwork();
void Inet_FinalizeNetwork();
bool Inet_IsConnected();

#endif
