﻿/*---------------------------------------------------------------------------*
  Project:  Pia
  File:     Shared_Inet_Setup.cpp

  Copyright (C) 2011-2014 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/

#include "SampleLib/SampleLib.h"
#include "Shared_Inet_Setup.h"

#include <pia/inet/inet_NexFacade.h>

nn::Result Inet_InitializePiaInet() {
    PIA_SAMPLE_LOG("Inet_InitializePiaInet\n");
    nn::Result result;

    nn::pia::inet::Setting setting;
    setting.mtuSize = SAMPLE_MTU_SIZE;
    
    result = nn::pia::inet::Initialize(setting);
    PIA_SAMPLE_ASSERT_RESULT_IS_SUCCESS(result);

    result = nn::pia::inet::BeginSetup();
    PIA_SAMPLE_ASSERT_RESULT_IS_SUCCESS(result);

    result = nn::pia::inet::NexFacade::CreateInstance();
    PIA_SAMPLE_ASSERT_RESULT_IS_SUCCESS(result);

    result = nn::pia::inet::EndSetup();
    PIA_SAMPLE_ASSERT_RESULT_IS_SUCCESS(result);

    // Print out the amount of consumed memory
    PIA_SAMPLE_PRINT("Inet_InitializePiaInet:Pia current memory usage: %d\n", nn::pia::common::GetMemoryUsage());
    return result;
}

void Inet_FinalizePiaInet() {
    PIA_SAMPLE_LOG("Inet_FinalizePiaInet\n");

// With Pia, Finalize and DestroyInstance always succeed
    nn::pia::inet::NexFacade::DestroyInstance();
    nn::pia::inet::Finalize();

    PIA_SAMPLE_LOG("Inet_FinalizePiaInet:finished\n");
}
