﻿/*---------------------------------------------------------------------------*
  Project:  Pia
  File:     Shared_Session_Setup.h

  Copyright (C)2011-2014 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/

#ifndef SHARED_SESSION_SETUP_H_
#define SHARED_SESSION_SETUP_H_

#include <pia/platform.h>
#include <pia/session.h>
#include <pia/transport/transport_NetworkFactory.h>

nn::Result Session_InitializePiaSession(nn::pia::transport::NetworkFactory*);
nn::Result Session_InitializePiaSession( const nn::pia::session::Session::Setting& setting );
nn::Result Session_InitializePiaSession(
    const nn::pia::session::Session::Setting& setting,
    bool isEnableRelayEmulation
);
void Session_FinalizePiaSession();

nn::Result Session_StartupSession(
    const nn::pia::common::SignatureSetting& signatureSetting,
    const nn::pia::transport::Station::IdentificationToken* pToken = NULL
);
nn::Result Session_StartupSession(
    u32 maxSilenceTime,
    u32 keepAliveSendingInterval,
    const nn::pia::common::SignatureSetting& signatureSetting,
    const nn::pia::transport::Station::IdentificationToken* pToken = NULL
);
void Session_CleanupSession();


#endif
