/*---------------------------------------------------------------------------*
  Project:  Voice Chat Sample.
  File:     utilities.cpp

  Copyright (C)2013-2014 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/


#include "utilities.h"


#if VCT_PLATFORM_CTR


CriticalSection::CriticalSection()
{
}

CriticalSection::~CriticalSection()
{
}

void CriticalSection::Initialize()
{
    m_CriticalSection.Initialize();
}

void CriticalSection::Finalize()
{
    m_CriticalSection.Finalize();
}

void CriticalSection::Lock()
{
    m_CriticalSection.Enter();
}

void CriticalSection::Unlock()
{
    m_CriticalSection.Leave();
}


#elif NN_VCT_TARGET_CAFE


CriticalSection::CriticalSection()
{
}

CriticalSection::~CriticalSection()
{
}

void CriticalSection::Initialize()
{
    OSInitMutex(&m_Mutex);
}

void CriticalSection::Finalize()
{
}

void CriticalSection::Lock()
{
    OSLockMutex(&m_Mutex);
}

void CriticalSection::Unlock()
{
    OSUnlockMutex(&m_Mutex);
}


#else
  #error "invalid platform";
#endif
