Search.additionalData = [
["title.html","VCT Library Programming Manual",
"VCT Library Programming Manual\nVersion 2.0.2\nMicrosoft Internet Explorer 8.0 is recommended.\n\tNintendo Confidential\n\tThe content of this document is highly confidential and should be handled accordingly.\nThe content of this document cannot be duplicated, copied, reprinted, transferred, distributed, or loaned in whole or in part without the prior approval of Nintendo.\nThis document contains confidential and proprietary information of Nintendo and is also protected under the copyright laws of the United States and foreign countries.\nNo part of this document may be released, distributed, transmitted or reproduced in any form or by any electronic or mechanical means, including information storage and retrieval systems, without permission in writing from Nintendo.\n© 2014 Nintendo. All rights reserved.\nAll company and product names in this document are the trademarks or registered trademarks of their respective companies.\nCTR-06-0162-001-K\n",0]
,["Heads/Header_14778466.html","1. Audio Frame Length",
"1. Audio Frame Length\nThe audio frame length is the unit for audio data sent and received. The default value is 144 ms. The audio frame length can be any value between 64 and 192 ms, set in increments of 8 ms.\nReducing the audio frame length reduces the packet size, which helps curb audio delays. But more packets than need to be sent per unit time increases the volume of communication. Conversely, increasing the audio frame length helps curb the volume of communications, but at the expense of more audio delays. Adjust the value according to the volume of communications in your game.\nCONFIDENTIAL\n",0]
,["Heads/Header_14778468.html","2. Audio Codec",
"2. Audio Codec\nVoiceChat only supports encoded audio sampled at 16 bits/8 kHz. In addition, it only supports 4-bit ADPCM encoding.\nIn conference mode, you need ( (Number of participants – 1) * 2 ) times the bandwidth.\nTable 2-1 Relationship Between the Audio Frame Length and the Size of Audio Data\n \tAudio Frame Length\n \tSize of Audio Data (bytes)\n \t64 ms (minimum)\n \t 260\n \t144 ms (default)\n \t 580\n \t192 ms (maximum)\n \t 772\n These audio data sizes refer only to the payload. Added to this are the IP header, the UDP header, the communications library header, and the VCT library audio packet header (12 bytes).\nCONFIDENTIAL\n",0]
,["Heads/Header_14778474.html","4. Voice Activity Detection (VAD)",
"4. Voice Activity Detection (VAD)\nThe VCT library uses Voice Activity Detection (VAD) functionality to detect when there is talking. Enabling VAD saves bandwidth and reduces the CPU load because audio packets are not transmitted when there is no talking. You can either enable VAD (which is the default state), or disable it using VCT_EnableVAD.\nThe following figure provides an overview of VAD features and details about the adjustment parameters.\n Figure 4-1 VAD Parameters\n The segment marked (1) in Figure 4-1 indicates the amount of change in audio volume used for detecting the transition from silence to a frame containing speech. The active gain set with the VCT_SetVADActiveGain function is a ratio (350% by default) that serves as a threshold for detecting this transition from silence to talking. Talking is determined to have started if the average speech power in the current audio frame is higher than the average speech power for the four past frames at the time of the preceding audio frame by an amount of more than the active gain ratio (3.5-fold by default). Setting a smaller value for the active gain makes it easier to detect the start of talking.\nThe inactive gain set with the VCT_SetVADInactiveGain function is a ratio (280% by default) that serves as a threshold for detecting the transition from to talking to silence. Lack of talking (silence) is detected if the average speech power for the four past frames at the time of the current audio frame is lower than the average speech power for the four most recent frames when talking was last detected by an amount that is more than the inactive gain ratio (2.8-fold by default). Setting a larger value for the inactive gain makes it easier to detect silence.\nIf packet transmission is stopped immediately when silence is detected, listeners hear breaks in the talking because package transmission was stopped by interruptions such as a glottal stop and other extremely short sounds, and by the talker pausing for breath. For this reason, the VCT library sets a VAD release time (segment (3) in Figure 4-1). VAD does not transition to the silence state unless the conditions for detecting silence continue to be satisfied throughout this release time. The default value is 720 ms (144 ms x 5), and you can change it by using the VCT_SetVADReleaseTime function.\n Segment (4) in Figure 4-1 represents the average audio power threshold for unconditionally treating a frame as silent, as set by the VCT_SetVADClampGain function. If the current frame's average power is less than or equal to a specified value, the frame is processed as silent because this is an abnormal value. Frames determined to be silent based on this condition are not used in calculating the average audio power of silent frames, which is a value needed for detecting these transitions between talking and silence.\nFor more information about the functions for setting these parameters, see the function reference.\nCONFIDENTIAL\n",0]
,["Heads/Header_14778476.html","5. Spare Packets",
"5. Spare Packets\nEnable this feature to boost the tolerance to packet loss. You can either enable spare packets (the default state) or disable them using VCT_EnableSparePacket.\nSpare packets are appended to the end of the normally used audio packets (called the main packets). Spare packets contain a compressed copy of the audio from the preceding main packet. Any packets lost on the receiver side can be filled in using the audio data in the spare packets included in the next packet, restoring otherwise lost audio frames. This helps maintain audio quality in the wireless environment and other environments prone to packet loss.\nTo minimize the increase in bandwidth usage, 2bit ADPCM is the only codec supported for spare packets.\nCONFIDENTIAL\n",0]
,["Heads/Header_14778484.html","3. Echo Canceller",
"3. Echo Canceller\nThe Echo Canceller feature reduces the echo effect that can occur when the microphone picks up the audio from the speaker output and sends it back to the originating party. This allows for smooth conversations even without using headsets.\nThe CTR-VCT default setting is \"echo canceller enabled.\" For more information, see the sample demo.\nCONFIDENTIAL\n",0]
,["Heads/Header_14778488.html","6. Audio Data Format",
"6. Audio Data Format\nThe following table presents the format of the audio data.\nTable 6-1 Audio Data Content\n \tMagic token. 0x5f564354. (The _VCT value is defined by VCT_MAGIC_PACKET_HEADER.)\n \tOther header information (8 bytes).\n \tPayload\n The audio data has a total header size of 12 bytes.\nCONFIDENTIAL\n",0]
,["Heads/Header_14778492.html","1. Initializing and Finalizing the Library",
"1. Initializing and Finalizing the Library\nThe VCT library must be initialized with the VCT_Init function before any library functions can be used.\nDuring initialization, you must use the VCTConfig structure to specify the various parameters. The following table shows the members of the VCTConfig structure.\n Table 1-1 The VCTConfig Structure\n \t Variable Name\n \t Description\n \t session\n \t Specifies the region where the VCTSession structure is saved.\n \t numSession\n \t Specifies the size of the region specified by session.\n \t mode\n \t Specifies the chat mode. (Be sure to specify VCT_MODE_CONFERENCE.)\n \tecMode \tSpecifies echo canceller's operating mode.\n \t cid\n \t Specifies the CID of terminals.\n \t codec\n \t Specifies the codec for the main packet. (Be sure to specify VCT_CODEC_4BIT_ADPCM.)\n \t frameLength\n \t Specifies the audio frame length in milliseconds.\n \t flag\n \t Enables or disables the VAD, spare packet, drop recovery, high-pass filter, and echo cancellation features.\n \t audioBuffer\n \t Specifies the receiving buffer for the audio stream. (It must be 32-byte aligned.)\n \t audioBufferSize\n \t Specifies the size of the buffer specified by audioBuffer.\n \t callback\n \t Specifies the callback function for when events occur.\n \t sendCallback\n \t Specifies the callback function for when data is sent.\n \t userData\n \t Specifies the user data to pass upon calling the callback function.\nThe following code shows an example of conference mode initialization.\n Code 1-1 Example of Initialization in Conference Mode\n static VCTSession s_vctSession[VCT_MAX_SESSION];\nstatic u8 s_audioBuffer[8 * 8 * VCT_AUDIO_BUFFER_SIZE] NN_ATTRIBUTE_ALIGN (32);\nstatic VCTConfig s_vctConfig;\ns_vctConfig.session = s_vctSession;\ns_vctConfig.numSession = VCT_MAX_SESSION;\ns_vctConfig.mode = VCT_MODE_CONFERENCE;\ns_vctConfig.ecMode = VT_EC_STANDARD;\ns_vctConfig.cid = MyCID;\ns_vctConfig.codec = VCT_CODEC_4BIT_ADPCM;\ns_vctConfig.frameLength = VCT_AUDIO_FRAME_LENGTH_DEFAULT;\ns_vctConfig.flag = VCT_CONFIG_FLAG_DEFAULT;\ns_vctConfig.audioBuffer = s_audioBuffer;\ns_vctConfig.audioBufferSize = 8 * 8 * VCT_AUDIO_BUFFER_SIZE;\ns_vctConfig.callback = VoiceChatEventCallback;\ns_vctConfig.sendCallback = VoiceChatSendDataCallBack;\ns_vctConfig.userData = myData;\nVCT_Init (&s_vctConfig);\nIn this sample code, exactly VCT_MAX_SESSION number of sessions are allocated. In conference mode, the required number of sessions is (maximum_number_of_participants -1).\nSpecify the chat mode and the CID of the local host, followed by the buffer for audio streaming.\nSpecify an audio stream buffer that is large enough for at least (audio frame length x 2) milliseconds of audio, so that there are no breaks in audio playback. The recommended size is at least (audio frame length x 4) milliseconds.\nThe buffer size is specified in terms of units of audio packet length. In this sample code, a buffer of size (8 * VCT_AUDIO_BUFFER_SIZE) is allocated.\nIn conference mode, the buffer size must be increased in proportion to the number of clients participating in the conference.\nFor example, if there is a conference with four participants and you want to provide this amount of buffer for each client, you would allocate a buffer of size (3 * (8 * VCT_AUDIO_BUFFER_SIZE)). Increasing the buffer size does not cause any delay in audio playback. The actual buffer size is determined automatically by the dynamic jitter buffer by measuring jitter on the network.\nThe pointer to the audio streaming buffer must be aligned to 32 bytes, and audioBufferSize must be an integral multiple of VCT_AUDIO_BUFFER_SIZE.\nSpecify the callback function and the parameter passed to that function, and then specify the codec for the main packet. The only codec currently supported for main packets is 4-bit ADPCM.\nNext, specify the audio frame length. VCT_AUDIO_FRAME_LENGTH_DEFAULT has a value of 144 milliseconds.\nFinally, specify whether to enable or disable VAD, spare packets, and the other individual features of the VCT library.\nFor more information about how to specify these values and more information about the various features, see the function reference manual.\nWhen you are finished using the VCT library, call the VCT_Cleanup function.\nCONFIDENTIAL\n",0]
,["Heads/Header_14778496.html","3. Receiving",
"3. Receiving\nThe data received by the receiving function of the communications library (which in the case of the PIA library is the nn::pia::transport::UnreliableProtocol::Receive function) can be either data for the game or data for VoiceChat.\nThe VCT_HandleData function looks at the received data to determine whether it is VoiceChat data, and performs the necessary processing if it is. To determine whether the data is meant for VoiceChat, the function looks for the Magic Token in the first four bytes of the received data. (See 6. Audio Data Format.)\nThe following example shows how this function is used.\n Code 3-1 Handling Received Data (for the PIA Library)\n result = nn::pia::transport::Transport::GetInstance()->GetProtocol<nn::pia::transport::UnreliableProtocol>(s_UnreliableProtocolHandle)->Receive(&srcId, recvBuf, &recvSize, sizeof(recvBuf));\nif(result.IsSuccess())\n{\n BOOL flag = VCT_HandleData( static_cast<u16>((srcId + 1) & 0xFFFF)), recvBuf, recvSize);\n if (flag == FALSE)\n {\n /*\n If the return value is FALSE, either the received data is not VoiceChat data,\n or the VCT library has not been initialized.\n Implement the processing required for the game here.\n */\n }\n}\n \nIf the return value is TRUE, the received data is VCT library data. In this case, the necessary processing is conducted inside the VCT_HandleData function and the callback function is called.\nCONFIDENTIAL\n",0]
,["Heads/Header_14778502.html","2. Sending",
"2. Sending\nSending is performed by the VCT_Main function. By calling the VCT_Main function, the send callback set in VCTConfig gets called when voice data needs to be sent. Use the communication library's send function (which in the case of the Pia library is nn::pia::transport::UnreliableProtocol::Send) inside the application's send callback to send the audio data.\nThe sending process inside VCT_Main (that is, the call to the send callback) must be run a sufficient number of times, so you also must call VCT_Main a sufficient number of times.\nGiven an audio frame length of length ms and the need to send to num number of peers, you must call the function at least (num * 1000 / length) times in one second. For example, if the audio frame length is 144 ms and there are 8 connected systems, the calculation is 7 * 1000 / 144 = 48.6. You would need to call the function about 50 to 60 times per second.\nBecause audio processing is conducted on a periodic basis, call the function periodically if at all possible, rather than in spurts. For example, call the function the necessary number of times in each game frame.\nCONFIDENTIAL\n",0]
,["Heads/Section_14778406.html","Introduction",
"Introduction\nThis document provides an overview of the VCT library and describes its features and the procedures for programming with it.\nThe VCT library is a library used for voice chat over the Internet. VCT is an abbreviation of Voice ChaT.\nThe VCT library requires the use of a P2P communications library like Pia to send and receive audio data. The sample code in the sample demo uses the Pia library in its explanations.\nFor reference, PiaChat equipped with the same features as the VCT library has been prepared in the Pia library. If your application is using the Pia library, we recommend that you use PiaChat, because when you use PiaChat the packets are bundled with other communications packets.\nCONFIDENTIAL\n",0]
,["Heads/Section_14778411.html","Chat Modes",
"Chat Modes\nThe VCT library provides a conference mode where the users of multiple systems can chat at the same time.\n",0]
,["Heads/Section_14778411.html","(no title)",
"Conference Mode\nIn conference mode, participants can all talk at the same time. This mode supports conversations among up to eight systems.\n Figure 1 Conversation in Conference Mode\n Fig. 1 Conversation in Conference Mode depicts four systems (parties A through D) participating in a session. Even if one of the participants (A) is currently talking, all of the other participants (B, C, and D) can still talk.\nIn conference mode, no system needs to act as the host machine because there is no need to control the conversation (that is, to control who is currently talking, who is participating in the conversation, and who can send a request to talk). However, the game must determine which systems can participate in the conference.\nCONFIDENTIAL\n",0]
,["Heads/Section_14778417.html","Library Overview",
"Library Overview\nThe VCT library has two function blocks.\n \tConversation session management. \tAudio streaming.\n Figure 1 Library Overview\nCONFIDENTIAL\n",0]
,["Heads/Section_14778419.html","Conversation Session Management",
"Conversation Session Management\nSystems participating in the chat session are distinguished by a unique number called a Connection ID (CID). The CID of the local system is specified in the VCTConfig structure that is passed to the VCT_Init function. Any value can used for this CID, providing it is a 16-bit value that is different for every system. If you are using the PiaSession component of the Pia library, you can use the station ID as the CID.\nKeep-alive packets to maintain the chat session are not sent. If you need to use keep-alive functionality, you must implement the process in your application.\nConversations can start immediately, simply by the application specifying the participants in the conference and calling the audio streaming API.\nThe library user should create and manage the conference group according to the game.\nCONFIDENTIAL\n",0]
,["Heads/Section_14778460.html","Audio Streaming",
"Audio Streaming\nThe devices in an established conversation session transmit audio data to each other for the purpose of voice chatting.\nThis component contains the following chapters.\n1. Audio Frame Length\n2. Audio Codec\n3. Echo Canceller\n4. Voice Activity Detection (VAD)\n5. Spare Packets\n6. Audio Data Format\nCONFIDENTIAL\n",0]
,["Heads/Section_14778490.html","About the Library API",
"About the Library API\nThis chapter describes how the library is used in practical situations.\nIf your application is using the VCT library, include the following header file.\n Code 1 Including the Header File\n #include <vct.h>\nIn addition, link to $CTRMW_VCT_ROOT/libraries/CTR-TS.Process.MPCore/(noopt|release|verbose)/libmw_vct.fast.a.\nNote:\n The VCT API is not thread-safe. Operation is not guaranteed if API functions are called from multiple threads.\n This component contains the following chapters.\n 1. Initializing and Finalizing the Library\n 2. Sending\n 3. Receiving\nCONFIDENTIAL\n",0]
,["Heads/Section_14778508.html","About the Sample Program",
"About the Sample Program\n",0]
,["Heads/Section_14778508.html","From Starting the Program Through Matchmaking",
"From Starting the Program Through Matchmaking\nStart the sample program and select Start Network to connect to an access point and log on to the game server. Note that the access point you are connecting to must already be registered in the System Settings.\nYou must also have established a friend relationship to set the matchmaking mode to Friend and perform communication between friends.\nWhen changing the matchmaking mode or other settings, press Up or Down on the +Control Pad to select the item to change, and then press Left or Right to change the setting value.\nMatchmaking requires that all participating systems have the same settings for the matchmaking mode, the game mode, and the maximum number of matchmaking connections. Make sure these parameters are the same for all communicating systems.\n Figure 1 Network Start Menu Screen\n ----------------------------------------\n<<<< Network Start Menu >>>>\n----------------------------------------\n> Network Match Mode  : ANYBODY\n Game Mode           : 1000\n  Max Station Num     : 8\n  Start Network...\nThe following table contains descriptions of the menu items.\n Table 1 Items in the Network Start Menu\n \t Menu Item\n \t Description\n \t Network Match Mode\n \t Specifies ANYBODY or FRIEND as the matchmaking mode.\n \t Game Mode\n \t Specifies the game mode.\n \t Max Station Num\n \t Specifies the maximum number of matchmaking connections.\n \t Start Network\n \t Starts a network connection.\n After connecting to the access point and logging in to the game server, the screen displays information about the network and a choice of conference mode.\n Figure 2 Network Information/Game Menu Selection Screen\n ----------------------------------------------------\n<<<< Network Information... >>>>\n----------------------------------------------------\n HOST            : xxx.xxx.xxx.xxx\n MASK            : xxx.xxx.xxx.xxx\n DNS1 : xxx.xxx.xxx.xxx\n DNS2 : xxx.xxx.xxx.xxx\n GATEWAY       : xxx.xxx.xxx.xxx\n MAC : xx:xx:xx:xx:xx:xx\n MY ConnectionID : x\n MY PID          : xxxxxxxxx\n OWNER PID       : xxxxxxxxx\n \n----------------------------------------------------\n----------------------------------------\n<<<< Network Connected >>>>\n----------------------------------------\n \n> Conference Mode Menu...\n  Stop Network...\nThe following table describes the Network Information screen.\n Table 2 The Network Information Screen\n \t Menu Item\n \t Description\n \t HOST\n \t The local host's IP address.\n \t MASK\n \t The net mask.\n \tDNS1 \tThe IP address of the primary DNS server.\n \tDNS2 \tThe IP address of the secondary DNS server.\n \t GATEWAY\n \t The IP address of the default gateway.\n \tMAC \tThe local system's MAC address.\n \t MY ConnectionID\n \t The local system's CID.\n \t MY PID\n \t The local system's PID.\n \t OWNER PID\n \t The session owner's PID.\nOn the Game Menu selection screen, use the +Control Pad to select the Conference Mode Menu, and then press the A Button to set the conference mode and display its Start screen.\nIf you select Stop Network and press the A Button, the system disconnects from the network and returns to the Network Start Menu screen.\nIn addition, by pressing the L Button in this screen, you can select the echo canceller's mode (when in debug mode), from either high performance mode or standard mode.\n",0]
,["Heads/Section_14778508.html","Conference Mode Sample Program",
"Conference Mode Sample Program\nWhen you select Conference Mode Menu from the Game Menu selection screen and then select Config Conference the following screen appears.\n Figure 3 Conference Mode Config Screen\n ----------------------------------------\n<<<< Config Conference >>>>\n----------------------------------------\n> Frame Length        :\n  Codec               :\n  Spare Packet        :\n  Spare Codec         :\n  Drop Recover        :\n  High-Pass filter    :\n  Biquad filter       :\n  Echo Canceller      :\n  VAD                 :\n  Active Gain         :\n  Inactive Gain       :\n  Clamp Gain          :\n  Release Time        :\n  Noise Skip Time     :\n  Return...\nThe following table describes the Conference Mode Information and Configuration Screen.\n Table 3 Conference Mode Information and Configuration Screen\n \t Menu Item\n \t Description\n \t Frame Length\n \t Audio Frame Length\n \t Codec\n \t Main-packet codec\n \t Spare Packet\n \t Whether spare packets are enabled.\n \t Spare Codec\n \t The codec of the spare packet.\n \t Drop Recover\n \t Whether drop recovery is enabled.\n \t High-Pass filter\n \t Whether the high-pass filter is enabled.\n \tBiquad filter \tWhether the biquad filter is enabled. (Normally it is disabled.)\n \tEcho Canceller \tWhether the Echo Canceller is enabled. (Normally it is enabled.)\n \t VAD\n \t Whether voice activity detection is enabled.\n \t Active Gain\n \t Threshold for detecting a speech frame.\n \t Inactive Gain\n \t Threshold for detecting a silent frame.\n \t Clamp Gain\n \t The threshold for unconditionally detecting silence (volume scale).\n \t Release Time\n \t How long to wait to stop sending packets after detecting silence.\n \tNoise Skip Time \t The duration of time audio is not sent, due to VCT_SignalNoiseSkip.\n Press Up or Down on the +Control Pad to select the item to change, and then press Left or Right to change the setting value.\nAfter completing the settings in the Config Menu, select Start Conference to start the conference game and display the following screen.\n Figure 4 Conference Mode Working Screen\n ----------------------------------------------------\n<<<<          Audio Information...              >>>>\n----------------------------------------------------\n ConnectionID              : 0x----\n Sequence                  : ---\n Internal Latency          : ---\n Buffer Latency : ---\n Jiitter : ---\n Clock Skew : ---\n Buffer Count              : ---\n Drop Count                : ---\n Continuous Drop           : ---\n Jam Count                 : ---\n Duplicate Count           : ---\n Wait Count                : ---\n Late Count                : ---\n Recent Late Count         : ---\n Recent Receive Count      : ---\n Recent Late Ratio         : ---\n Recover Count             : ---\n Recover Using Spare Count : ---\n VAD Value                 : ---\n----------------------------------------------------\n \n    ----------------------------------------\n    <<<<      Conference working.       >>>>\n    ----------------------------------------\n      MY ConnectionID(0x----)\n    > Member[CID:0x----] : PARTICIPATE/LEAVE\n      Member[CID:0x----] : PARTICIPATE/LEAVE\n      Member[CID:0x----] : PARTICIPATE/LEAVE\n      Member[CID:0x----] : PARTICIPATE/LEAVE\n      Member[CID:0x----] : PARTICIPATE/LEAVE\n      Member[CID:0x----] : PARTICIPATE/LEAVE\n      Member[CID:0x----] : PARTICIPATE/LEAVE\n      Member[CID:0x----] : PARTICIPATE/LEAVE\n      Change Setting...\n      Stop Conference...\nUse the +Control Pad to move the cursor in the main menu and then press the A button to add or remove the specified client. This operation must be repeated for every client participating in the conference. After a client has been added to the conference, it can chat without any special operations.\nThe Change Setting submenu displays the current settings and allows you to change them while the conference is running.\nTo end a conference, select Stop Conference in the main menu and press the A Button. This takes you back to the Game Menu selection screen.\nThe following table describes the audio streaming information displayed on the screen.\n Table 4 Audio Streaming Information Screen\n \t Menu Item\n \t Description\n \t ConnectionID\n \t CID of the displayed audio information.\n \t Sequence\n \t Packet sequence number.\n \tInternal Latency \tInternal receive latency amount.\n \t Buffer Latency\n \t Latency of the jitter buffer.\n \t Jitter\n \t Maximum latency of the jitter buffer.\n \t Clock Skew\n \t Clock skew monitor value.\n \t Buffer Count\n \t Number of samples stored in the audio buffer.\n \t Drop Count\n \t Number of dropped packets.\n \t Continuous Drop\n \t Number of consecutively dropped packets.\n \t Jam Count\n \t Number of times packets did not arrive in order.\n \t Duplicate Count\n \t Number of duplicate packet sequence numbers.\n \t Wait Count\n \t Number of times packet playback was deferred and drop recovery attempted.\n \t Late Count\n \t Number of packets that could not be played back because of delays.\n \t Recent Late Count\n \t Number of most recent packets that could not be played back because of delays.\n \t Recent Receive Count\n \t Total number of the most recent packets.\n \t Recent Late Ratio\n \t Ratio of the most recent packets that could not be played back because of delays.\n \t Recover Count\n \t Number of times the drop recovery feature recovered dropped packets, without using spare packets.\n \t Recover Using Spare Count\n \t Number of times dropped packets were recovered using spare packets.\n \tVAD Value \tThe result determined by VAD for the presence or absence of audio.\n Use the L/R Buttons on the Audio Streaming Information screen to change the peer for which information is being shown.\nCONFIDENTIAL\n",0]
,["Heads/Section_14778510.html","Revision History",
"Revision History\n",0]
,["Heads/Section_14778510.html","Version 2.0.2  2014/02/13",
"Version 2.0.2 2014/02/13\n",0]
,["Heads/Section_14778510.html","Changed",
"Changed\n \t About the API\n Noted that operation is not guaranteed if the VCT API is called from multiple threads. \t About the Sample Program\n Revised tables and other information in line with changes to the sample program.\n",0]
,["Heads/Section_14778510.html","Version 2.0.1  2014/01/08",
"Version 2.0.1 2014/01/08\n",0]
,["Heads/Section_14778510.html","Changes",
"Changes\n \tNo changes to the programming manual.\n",0]
,["Heads/Section_14778510.html","Version 2.0.0  2013/11/28",
"Version 2.0.0 2013/11/28\n",0]
,["Heads/Section_14778510.html","Changes",
"Changes\n \tDeleted mentions of transceiver mode and SSP. \tDeleted mentions of the 2-bit ADPCM codec for main packets. \tDeleted mentions of quality alerts.\n",0]
,["Heads/Section_14778510.html","Version 1.9.1  2013/06/11",
"Version 1.9.1 2013/06/11\n",0]
,["Heads/Section_14778510.html","Changes",
"Changes\n \tReorganized the overall structure.\n",0]
,["Heads/Section_14778510.html","Version 1.9.0  2013/04/25",
"Version 1.9.0 2013/04/25\n",0]
,["Heads/Section_14778510.html","Changes",
"Changes\n \t Introduction\n Revised the description of the library being used.\n",0]
,["Heads/Section_14778510.html","Version 1.1.0  2012/09/10",
"Version 1.1.0 2012/09/10\n",0]
,["Heads/Section_14778510.html","Changes",
"Changes\n \t About the Sample Program\n Deleted the items related to the MAC address from Figure 2 Network Information/Game Menu Selection Screen and from Table 2 Network Information Screen.\n",0]
,["Heads/Section_14778510.html","Version 1.0.0  2012/07/24",
"Version 1.0.0 2012/07/24\n",0]
,["Heads/Section_14778510.html","Changes",
"Changes\n \t Chat Modes\n Changed the number of participants allowed in a conversation from four to eight.\n",0]
,["Heads/Section_14778510.html","Version 0.9.0  2012/05/25",
"Version 0.9.0 2012/05/25\n",0]
,["Heads/Section_14778510.html","Additions",
"Additions\n \tVCT Programming Manual\nInitial version.\nCONFIDENTIAL\n",0]
,["external.html?file=../../../API/html/annotated.html","CTR-VCT: Compound List Members",
"Here are the data structures with brief descriptions:\n\tVCTAudioInfo\tStores information related to audio\n\tVCTConfig\tStores initialization parameters for the VCT library\n\tVCTSession\tDefines the structure for a session. Used for managing CIDs and the session state\n",1]
,["external.html?file=../../../API/html/classes.html","CTR-VCT: Class Index",
"V\n\t\t  V  \n\tVCTConfig   \t\n\tVCTSession   \t\n\tVCTAudioInfo   \t\t\n\t\t\t\nV\n",1]
,["external.html?file=../../../API/html/date.html","CTR-VCT: Revision History",
"Global VCT_AddConferenceClient (u16 cid)\n\t2013/06/11 Fixed a mistake in the description of the return value.\n2011/08/31 Initial version.\nGlobal VCT_Cleanup (void)\n\t2011/08/31 Initial version.\nGlobal VCT_ClearStreaming (const VCTSession *session)\n\t2013/02/15 Initial version.\nGlobal VCT_DeleteSession (VCTSession *session)\n\t2011/08/31 Initial version.\nGlobal VCT_EnableSparePacket (bool flag)\n\t2011/08/31 Initial version.\nGlobal VCT_EnableVAD (bool flag)\n\t2011/08/31 Initial version.\nGlobal VCT_GetAudioDataSize (void)\n\t2011/08/31 Initial version.\nGlobal VCT_GetAudioFrameLength (void)\n\t2011/08/31 Initial version.\nGlobal VCT_GetAudioInfoFromCid (u16 cid, VCTAudioInfo *info)\n\t2011/08/31 Initial version.\nGlobal VCT_GetAudioScale (const void *audio, u32 length)\n\t2012/04/19 - Corrected the description of the length argument by changing \"number of samples\" to \"number of bytes.\"\n2011/09/29 - Clarified that the audio variable is const.\n2011/08/31 Initial version.\nGlobal VCT_GetCodec (void)\n\t2011/08/31 Initial version.\nGlobal VCT_GetNoiseSkipTime (void)\n\t2012/03/01 Initial version.\nGlobal VCT_GetSpareCodec (void)\n\t2011/08/31 Initial version.\nGlobal VCT_GetVADActiveGain (void)\n\t2011/08/31 Initial version.\nGlobal VCT_GetVADActivity (void)\n\t2011/08/31 Initial version.\nGlobal VCT_GetVADClampGain (void)\n\t2011/08/31 Initial version.\nGlobal VCT_GetVADInactiveGain (void)\n\t2011/08/31 Initial version.\nGlobal VCT_GetVADReleaseTime (void)\n\t2011/08/31 Initial version.\nGlobal VCT_HandleData (u16 cid, u8 *buffer, u32 size)\n\t2013/06/07 Revised the description.\n2011/08/31 Initial version.\nGlobal VCT_HandleReference (const u8 *buffer, u32 size)\n\t2011/09/29 - Clarified that the buffer variable is const.\n2011/08/31 Initial version.\nGlobal VCT_Init (VCTConfig *config)\n\t2011/08/31 Initial version.\nGlobal VCT_IsEnableSparePacket (void)\n\t2011/08/31 Initial version.\nGlobal VCT_IsEnableVAD (void)\n\t2011/08/31 Initial version.\nGlobal VCT_IsInitialized (void)\n\t2011/08/31 Initial version.\nGlobal VCT_IsValidCodec (VCTCodec codec)\n\t2011/08/31 Initial version.\nGlobal VCT_IsValidSpareCodec (VCTCodec codec)\n\t2011/08/31 Initial version.\nGlobal VCT_Main (void)\n\t2013/06/07 Added a description of the number of times to call VCT_Main.\n2011/08/31 Initial version.\nGlobal VCT_OnConferenceClient (u16 cid)\n\t2011/08/31 Initial version.\nGlobal VCT_ReceiveAudio (void *audio_data, u32 length, u16 outCIDList[])\n\t2012/04/03 - Revised the description of the outCIDList argument.\n2011/08/31 Initial version.\nGlobal VCT_RemoveConferenceClient (u16 cid)\n\t2011/08/31 Initial version.\nGlobal VCT_ResetVAD (void)\n\t2011/08/31 Initial version.\nGlobal VCT_SendAudioEx (const void *audio_data, u32 micScale, u32 micOffset)\n\t2011/09/29 The session variable was declared const.\n2011/08/31 Initial version.\nGlobal VCT_SetAudioFrameLength (u32 frameLength)\n\t2011/08/31 Initial version.\nGlobal VCT_SetCodec (VCTCodec codec)\n\t2011/08/31 Initial version.\nGlobal VCT_SetNoiseSkipTime (u32 count)\n\t2012/03/01 Initial version.\nGlobal VCT_SetSpareCodec (VCTCodec spareCodec)\n\t2011/08/31 Initial version.\nGlobal VCT_SetVADActiveGain (u16 value)\n\t2011/08/31 Initial version.\nGlobal VCT_SetVADClampGain (u32 value)\n\t2011/08/31 Initial version.\nGlobal VCT_SetVADInactiveGain (u16 value)\n\t2011/08/31 Initial version.\nGlobal VCT_SetVADReleaseTime (u32 count)\n\t2011/08/31 Initial version.\nGlobal VCT_SignalNoiseSkip (void)\n\t2012/05/10 - Revised the description.\n2012/03/15 - Supplemented the description.\n2012/03/01 Initial version.\nGlobal VCT_StartStreaming (const VCTSession *session)\n\t2011/09/29 - Clarified that the session variable is const.\n2011/08/31 Initial version.\nGlobal VCT_StopStreaming (const VCTSession *session)\n\t2011/09/29 The session variable was declared const.\n2011/08/31 Initial version.\nClass VCTConfig\n\t2011/10/21 Added the ecMode member to specify the operation mode of echo cancellation.\n",1]
,["external.html?file=../../../API/html/dir_5e185bdbad40c2ea37217656e3c5cb08.html","CTR-VCT: include/mw/vct Directory Reference",
" Directory dependency graph for vct:\n\tFiles\n\tfile  \tvct.h [code]\n\t \n",1]
,["external.html?file=../../../API/html/dir_d44c64559bbebec7f509842c48db8b23.html","CTR-VCT: include Directory Reference",
" Directory dependency graph for include:\n\tDirectories\n\tdirectory  \tmw\n\t \n",1]
,["external.html?file=../../../API/html/dir_ed46e123b15176efd73bb0ed987f3138.html","CTR-VCT: include/mw Directory Reference",
" Directory dependency graph for mw:\n\tDirectories\n\tdirectory  \tvct\n\t \n",1]
,["external.html?file=../../../API/html/files.html","CTR-VCT: File List",
"Here is a list of all files with brief descriptions:\n[detail level 1234]\n\tinclude\t\n\tmw\t\n\tvct\t\n\tvct.h\t\n",1]
,["external.html?file=../../../API/html/functions.html","CTR-VCT: Data Fields",
"Here is a list of all struct and union fields with links to the structures/unions they belong to:\n- _ -\n\t_next: VCTSession\t_padding0_: VCTSession\t_padding1_: VCTConfig, VCTSession\t_padding2_: VCTSession\n- a -\n\taudioBuffer: VCTConfig\taudioBufferSize: VCTConfig\n- b -\n\tbufferCount: VCTAudioInfo\tbufferLatency: VCTAudioInfo\n- c -\n\tcallback: VCTConfig\tcid: VCTSession, VCTConfig\tcidList: VCTSession\tclockSkew: VCTAudioInfo\tcodec: VCTAudioInfo, VCTConfig\tcontinuousDrop: VCTAudioInfo\n- d -\n\tdropCount: VCTAudioInfo\tduplicateCount: VCTAudioInfo\n- e -\n\tecMode: VCTConfig\n- f -\n\tflag: VCTConfig\tframeLength: VCTConfig\n- i -\n\tinternalLatency: VCTAudioInfo\n- j -\n\tjamCount: VCTAudioInfo\tjitter: VCTAudioInfo\n- l -\n\tlateCount: VCTAudioInfo\n- m -\n\tmode: VCTSession, VCTConfig\n- n -\n\tnumSession: VCTConfig\n- p -\n\tpadding0_: VCTAudioInfo\tpadding1_: VCTAudioInfo\n- r -\n\trecentLateCount: VCTAudioInfo\trecentLateRatio: VCTAudioInfo\trecentReceiveCount: VCTAudioInfo\trecoverCount: VCTAudioInfo\trecoverUsingSpareCount: VCTAudioInfo\n- s -\n\tsendCallback: VCTConfig\tsequence: VCTAudioInfo\tsession: VCTConfig\tstate: VCTSession\n- u -\n\tuserData: VCTSession, VCTConfig\n- w -\n\twaitCount: VCTAudioInfo\n",1]
,["external.html?file=../../../API/html/functions_vars.html","CTR-VCT: Data Fields - Variables",
" - _ -\n\t_next: VCTSession\t_padding0_: VCTSession\t_padding1_: VCTConfig, VCTSession\t_padding2_: VCTSession\n- a -\n\taudioBuffer: VCTConfig\taudioBufferSize: VCTConfig\n- b -\n\tbufferCount: VCTAudioInfo\tbufferLatency: VCTAudioInfo\n- c -\n\tcallback: VCTConfig\tcid: VCTSession, VCTConfig\tcidList: VCTSession\tclockSkew: VCTAudioInfo\tcodec: VCTAudioInfo, VCTConfig\tcontinuousDrop: VCTAudioInfo\n- d -\n\tdropCount: VCTAudioInfo\tduplicateCount: VCTAudioInfo\n- e -\n\tecMode: VCTConfig\n- f -\n\tflag: VCTConfig\tframeLength: VCTConfig\n- i -\n\tinternalLatency: VCTAudioInfo\n- j -\n\tjamCount: VCTAudioInfo\tjitter: VCTAudioInfo\n- l -\n\tlateCount: VCTAudioInfo\n- m -\n\tmode: VCTSession, VCTConfig\n- n -\n\tnumSession: VCTConfig\n- p -\n\tpadding0_: VCTAudioInfo\tpadding1_: VCTAudioInfo\n- r -\n\trecentLateCount: VCTAudioInfo\trecentLateRatio: VCTAudioInfo\trecentReceiveCount: VCTAudioInfo\trecoverCount: VCTAudioInfo\trecoverUsingSpareCount: VCTAudioInfo\n- s -\n\tsendCallback: VCTConfig\tsequence: VCTAudioInfo\tsession: VCTConfig\tstate: VCTSession\n- u -\n\tuserData: VCTSession, VCTConfig\n- w -\n\twaitCount: VCTAudioInfo\n",1]
,["external.html?file=../../../API/html/globals.html","CTR-VCT: Compound List",
"Here is a list of all functions, variables, defines, enums, and typedefs with links to the files they belong to:\n- v -\n\tVCT_AddConferenceClient(): vct.h\tVCT_AUDIO_2_BIT_ADPCM_PACKET_SIZE_MAX: vct.h\tVCT_AUDIO_3_BIT_ADPCM_PACKET_SIZE_MAX: vct.h\tVCT_AUDIO_4_BIT_ADPCM_PACKET_SIZE_MAX: vct.h\tVCT_AUDIO_BUFFER_PACKET_HEADER: vct.h\tVCT_AUDIO_BUFFER_SIZE: vct.h\tVCT_AUDIO_DATA_SIZE_DEFAULT: vct.h\tVCT_AUDIO_DATA_SIZE_MAX: vct.h\tVCT_AUDIO_DATA_SIZE_MIN: vct.h\tVCT_AUDIO_DATA_SIZE_PER_MILLI_SEC: vct.h\tVCT_AUDIO_FRAME_LENGTH_DEFAULT: vct.h\tVCT_AUDIO_FRAME_LENGTH_MAX: vct.h\tVCT_AUDIO_FRAME_LENGTH_MIN: vct.h\tVCT_AUDIO_FRAME_RATE: vct.h\tVCT_AUDIO_HEADER_SIZE: vct.h\tVCT_AUDIO_PACKET_BUFFER_SIZE: vct.h\tVCT_AUDIO_SPARE_PACKET_SIZE_MAX: vct.h\tVCT_Cleanup(): vct.h\tVCT_ClearStreaming(): vct.h\tVCT_CODEC_2BIT_ADPCM: vct.h\tVCT_CODEC_3BIT_ADPCM: vct.h\tVCT_CODEC_4BIT_ADPCM: vct.h\tVCT_CODEC_8BIT_RAW: vct.h\tVCT_CODEC_DEFAULT: vct.h\tVCT_CODEC_END: vct.h\tVCT_CODEC_G711_ULAW: vct.h\tVCT_CONFIG_FLAG_ALL: vct.h\tVCT_CONFIG_FLAG_BPF: vct.h\tVCT_CONFIG_FLAG_DEFAULT: vct.h\tVCT_CONFIG_FLAG_DROP_RECOVER: vct.h\tVCT_CONFIG_FLAG_ECHO_CANCEL: vct.h\tVCT_CONFIG_FLAG_HPF: vct.h\tVCT_CONFIG_FLAG_NONE: vct.h\tVCT_CONFIG_FLAG_SPARE_PACKET: vct.h\tVCT_CONFIG_FLAG_VAD: vct.h\tVCT_DEFAULT_AUDIO_BUFFER_COUNT: vct.h\tVCT_DEFAULT_AUDIO_BUFFER_SIZE: vct.h\tVCT_DeleteSession(): vct.h\tVCT_EC_HIGHPERFORMANCE: vct.h\tVCT_EC_STANDARD: vct.h\tVCT_EnableSparePacket(): vct.h\tVCT_EnableVAD(): vct.h\tVCT_ERROR_BAD_MODE: vct.h\tVCT_ERROR_BAD_PARAM: vct.h\tVCT_ERROR_BAD_REQUEST: vct.h\tVCT_ERROR_EXHAUST_CLIENTS: vct.h\tVCT_ERROR_NONE: vct.h\tVCT_ERROR_SEND_FAIL: vct.h\tVCT_EVENT_CONNECTED: vct.h\tVCT_EVENT_DISCONNECTED: vct.h\tVCT_EVENT_NONE: vct.h\tVCT_GetAudioDataSize(): vct.h\tVCT_GetAudioFrameLength(): vct.h\tVCT_GetAudioInfoFromCid(): vct.h\tVCT_GetAudioScale(): vct.h\tVCT_GetCodec(): vct.h\tVCT_GetNoiseSkipTime(): vct.h\tVCT_GetSpareCodec(): vct.h\tVCT_GetVADActiveGain(): vct.h\tVCT_GetVADActivity(): vct.h\tVCT_GetVADClampGain(): vct.h\tVCT_GetVADInactiveGain(): vct.h\tVCT_GetVADReleaseTime(): vct.h\tVCT_HandleData(): vct.h\tVCT_HandleReference(): vct.h\tVCT_Init(): vct.h\tVCT_IsEnableSparePacket(): vct.h\tVCT_IsEnableVAD(): vct.h\tVCT_IsInitialized(): vct.h\tVCT_IsValidCodec(): vct.h\tVCT_IsValidSpareCodec(): vct.h\tVCT_MAGIC_PACKET_HEADER: vct.h\tVCT_Main(): vct.h\tVCT_MAX_AUDIO_BUFFER_COUNT: vct.h\tVCT_MAX_AUDIO_STREAM: vct.h\tVCT_MAX_CLIENT: vct.h\tVCT_MAX_CONFERENCE_CLIENT: vct.h\tVCT_MAX_SESSION: vct.h\tVCT_MIN_AUDIO_BUFFER_COUNT: vct.h\tVCT_MODE_CONFERENCE: vct.h\tVCT_MODE_NULL: vct.h\tVCT_OnConferenceClient(): vct.h\tVCT_ReceiveAudio(): vct.h\tVCT_RemoveConferenceClient(): vct.h\tVCT_ResetVAD(): vct.h\tVCT_SendAudioEx(): vct.h\tVCT_SetAudioFrameLength(): vct.h\tVCT_SetCodec(): vct.h\tVCT_SetNoiseSkipTime(): vct.h\tVCT_SetSpareCodec(): vct.h\tVCT_SetVADActiveGain(): vct.h\tVCT_SetVADClampGain(): vct.h\tVCT_SetVADInactiveGain(): vct.h\tVCT_SetVADReleaseTime(): vct.h\tVCT_SignalNoiseSkip(): vct.h\tVCT_SPARE_CODEC_DEFAULT: vct.h\tVCT_StartStreaming(): vct.h\tVCT_STATE_INIT: vct.h\tVCT_STATE_TALKING: vct.h\tVCT_StopStreaming(): vct.h\tVCT_VAD_CLAMP_GAIN_MAX: vct.h\tVCT_VAD_DETECT_GAIN_UP_DEFAULT: vct.h\tVCT_VAD_INVALID_SCALE_THRESHOLD_DEFAULT: vct.h\tVCT_VAD_LOST_GAIN_UP_DEFAULT: vct.h\tVCT_VAD_RELEASE_TIME_DEFAULT: vct.h\tVCTCodec: vct.h\tVCTECMode: vct.h\tVCTEvent: vct.h\tVCTEventCallback: vct.h\tVCTMode: vct.h\tVCTSendCallback: vct.h\tVCTSession: vct.h\tVCTState: vct.h\n",1]
,["external.html?file=../../../API/html/globals_defs.html","CTR-VCT: Compound List",
" - v -\n\tVCT_AUDIO_2_BIT_ADPCM_PACKET_SIZE_MAX: vct.h\tVCT_AUDIO_3_BIT_ADPCM_PACKET_SIZE_MAX: vct.h\tVCT_AUDIO_4_BIT_ADPCM_PACKET_SIZE_MAX: vct.h\tVCT_AUDIO_BUFFER_PACKET_HEADER: vct.h\tVCT_AUDIO_BUFFER_SIZE: vct.h\tVCT_AUDIO_DATA_SIZE_DEFAULT: vct.h\tVCT_AUDIO_DATA_SIZE_MAX: vct.h\tVCT_AUDIO_DATA_SIZE_MIN: vct.h\tVCT_AUDIO_DATA_SIZE_PER_MILLI_SEC: vct.h\tVCT_AUDIO_FRAME_LENGTH_DEFAULT: vct.h\tVCT_AUDIO_FRAME_LENGTH_MAX: vct.h\tVCT_AUDIO_FRAME_LENGTH_MIN: vct.h\tVCT_AUDIO_FRAME_RATE: vct.h\tVCT_AUDIO_HEADER_SIZE: vct.h\tVCT_AUDIO_PACKET_BUFFER_SIZE: vct.h\tVCT_AUDIO_SPARE_PACKET_SIZE_MAX: vct.h\tVCT_CODEC_DEFAULT: vct.h\tVCT_CONFIG_FLAG_ALL: vct.h\tVCT_CONFIG_FLAG_BPF: vct.h\tVCT_CONFIG_FLAG_DEFAULT: vct.h\tVCT_CONFIG_FLAG_DROP_RECOVER: vct.h\tVCT_CONFIG_FLAG_ECHO_CANCEL: vct.h\tVCT_CONFIG_FLAG_HPF: vct.h\tVCT_CONFIG_FLAG_NONE: vct.h\tVCT_CONFIG_FLAG_SPARE_PACKET: vct.h\tVCT_CONFIG_FLAG_VAD: vct.h\tVCT_DEFAULT_AUDIO_BUFFER_COUNT: vct.h\tVCT_DEFAULT_AUDIO_BUFFER_SIZE: vct.h\tVCT_ERROR_BAD_MODE: vct.h\tVCT_ERROR_BAD_PARAM: vct.h\tVCT_ERROR_BAD_REQUEST: vct.h\tVCT_ERROR_EXHAUST_CLIENTS: vct.h\tVCT_ERROR_NONE: vct.h\tVCT_ERROR_SEND_FAIL: vct.h\tVCT_MAGIC_PACKET_HEADER: vct.h\tVCT_MAX_AUDIO_BUFFER_COUNT: vct.h\tVCT_MAX_AUDIO_STREAM: vct.h\tVCT_MAX_CLIENT: vct.h\tVCT_MAX_CONFERENCE_CLIENT: vct.h\tVCT_MAX_SESSION: vct.h\tVCT_MIN_AUDIO_BUFFER_COUNT: vct.h\tVCT_SPARE_CODEC_DEFAULT: vct.h\tVCT_VAD_CLAMP_GAIN_MAX: vct.h\tVCT_VAD_DETECT_GAIN_UP_DEFAULT: vct.h\tVCT_VAD_INVALID_SCALE_THRESHOLD_DEFAULT: vct.h\tVCT_VAD_LOST_GAIN_UP_DEFAULT: vct.h\tVCT_VAD_RELEASE_TIME_DEFAULT: vct.h\n",1]
,["external.html?file=../../../API/html/globals_enum.html","CTR-VCT: Compound List",
" \tVCTCodec: vct.h\tVCTECMode: vct.h\tVCTEvent: vct.h\tVCTMode: vct.h\tVCTState: vct.h\n",1]
,["external.html?file=../../../API/html/globals_eval.html","CTR-VCT: Compound List",
" \tVCT_CODEC_2BIT_ADPCM: vct.h\tVCT_CODEC_3BIT_ADPCM: vct.h\tVCT_CODEC_4BIT_ADPCM: vct.h\tVCT_CODEC_8BIT_RAW: vct.h\tVCT_CODEC_END: vct.h\tVCT_CODEC_G711_ULAW: vct.h\tVCT_EC_HIGHPERFORMANCE: vct.h\tVCT_EC_STANDARD: vct.h\tVCT_EVENT_CONNECTED: vct.h\tVCT_EVENT_DISCONNECTED: vct.h\tVCT_EVENT_NONE: vct.h\tVCT_MODE_CONFERENCE: vct.h\tVCT_MODE_NULL: vct.h\tVCT_STATE_INIT: vct.h\tVCT_STATE_TALKING: vct.h\n",1]
,["external.html?file=../../../API/html/globals_func.html","CTR-VCT: Compound List",
" - v -\n\tVCT_AddConferenceClient(): vct.h\tVCT_Cleanup(): vct.h\tVCT_ClearStreaming(): vct.h\tVCT_DeleteSession(): vct.h\tVCT_EnableSparePacket(): vct.h\tVCT_EnableVAD(): vct.h\tVCT_GetAudioDataSize(): vct.h\tVCT_GetAudioFrameLength(): vct.h\tVCT_GetAudioInfoFromCid(): vct.h\tVCT_GetAudioScale(): vct.h\tVCT_GetCodec(): vct.h\tVCT_GetNoiseSkipTime(): vct.h\tVCT_GetSpareCodec(): vct.h\tVCT_GetVADActiveGain(): vct.h\tVCT_GetVADActivity(): vct.h\tVCT_GetVADClampGain(): vct.h\tVCT_GetVADInactiveGain(): vct.h\tVCT_GetVADReleaseTime(): vct.h\tVCT_HandleData(): vct.h\tVCT_HandleReference(): vct.h\tVCT_Init(): vct.h\tVCT_IsEnableSparePacket(): vct.h\tVCT_IsEnableVAD(): vct.h\tVCT_IsInitialized(): vct.h\tVCT_IsValidCodec(): vct.h\tVCT_IsValidSpareCodec(): vct.h\tVCT_Main(): vct.h\tVCT_OnConferenceClient(): vct.h\tVCT_ReceiveAudio(): vct.h\tVCT_RemoveConferenceClient(): vct.h\tVCT_ResetVAD(): vct.h\tVCT_SendAudioEx(): vct.h\tVCT_SetAudioFrameLength(): vct.h\tVCT_SetCodec(): vct.h\tVCT_SetNoiseSkipTime(): vct.h\tVCT_SetSpareCodec(): vct.h\tVCT_SetVADActiveGain(): vct.h\tVCT_SetVADClampGain(): vct.h\tVCT_SetVADInactiveGain(): vct.h\tVCT_SetVADReleaseTime(): vct.h\tVCT_SignalNoiseSkip(): vct.h\tVCT_StartStreaming(): vct.h\tVCT_StopStreaming(): vct.h\n",1]
,["external.html?file=../../../API/html/globals_type.html","CTR-VCT: Compound List",
" \tVCTEventCallback: vct.h\tVCTSendCallback: vct.h\tVCTSession: vct.h\n",1]
,["external.html?file=../../../API/html/graph_legend.html","CTR-VCT: Graph Legend",
"This page explains how to interpret the graphs that are generated by doxygen.\nConsider the following example:\n/*! Invisible class because of truncation */\nclass Invisible { };\n/*! Truncated class, inheritance relation is hidden */\nclass Truncated : public Invisible { };\n/* Class not documented with doxygen comments */\nclass Undocumented { };\n/*! Class that is inherited using public inheritance */\nclass PublicBase : public Truncated { };\n/*! A template class */\ntemplate<class T> class Templ { };\n/*! Class that is inherited using protected inheritance */\nclass ProtectedBase { };\n/*! Class that is inherited using private inheritance */\nclass PrivateBase { };\n/*! Class that is used by the Inherited class */\nclass Used { };\n/*! Super class that inherits a number of other classes */\nclass Inherited : public PublicBase,\n protected ProtectedBase,\n private PrivateBase,\n public Undocumented,\n public Templ<int>\n{\n private:\n Used *m_usedClass;\n};\n This will result in the following graph:\nThe boxes in the above graph have the following meaning:\n\tA filled gray box represents the struct or class for which the graph is generated. \tA box with a black border denotes a documented struct or class. \tA box with a grey border denotes an undocumented struct or class. \tA box with a red border denotes a documented struct or class forwhich not all inheritance/containment relations are shown. A graph is truncated if it does not fit within the specified boundaries.\nThe arrows have the following meaning:\n\tA dark blue arrow is used to visualize a public inheritance relation between two classes. \tA dark green arrow is used for protected inheritance. \tA dark red arrow is used for private inheritance. \tA purple dashed arrow is used if a class is contained or used by another class. The arrow is labeled with the variable(s) through which the pointed class or struct is accessible. \tA yellow dashed arrow denotes a relation between a template instance and the template class it was instantiated from. The arrow is labeled with the template parameters of the instance.\n",1]
,["external.html?file=../../../API/html/index.html","CTR-VCT: API Reference Home",
"\nNintendo Confidential\nWarning\n\t\nThe contents of this document is highly confidential and should be handled accordingly. The contents of this document cannot be duplicated, copied, reprinted, transferred, distributed, or loaned, in whole or in part, without the prior approval of Nintendo. This document contains confidential and proprietary information of Nintendo and is also protected under the copyright laws of the United States and foreign countries. No part of this document may be released, distributed, transmitted, or reproduced in any form or by any electronic or mechanical means, including information storage and retrieval systems, without permission in writing from Nintendo.\nLibrary Usage And Implementation Notes\nFor more information about using the VoiceChat library, see the Programming Manual.\n CTR-06-0164-001-N\n",1]
,["external.html?file=../../../API/html/introduction_8txt.html","CTR-VCT: documents/API_Reference/src/introduction.txt File Reference",
"\n",1]
,["external.html?file=../../../API/html/pages.html","CTR-VCT: Related Pages",
"Here is a list of all related documentation pages:\n\tRevision History\t\n",1]
,["external.html?file=../../../API/html/struct_v_c_t_audio_info.html","CTR-VCT: VCTAudioInfo Struct Reference",
"Stores information related to audio. More...\nThe documentation for this struct was generated from the following file:\tinclude/mw/vct/vct.h\n\tData Fields\n\tVCTCodec \tcodec\n\t \tSpecifies the audio codec of the peer. More...\n\t \n\tu8 \tpadding0_ [3]\n\t \tRepresents a reserved region. More...\n\t \n\tu32 \tsequence\n\t \tSequence number of the current audio packet. More...\n\t \n\tnn::os::Tick \tbufferLatency\n\t \tLatency of the jitter buffer. More...\n\t \n\tnn::os::Tick \tjitter\n\t \tMaximum jitter (in ticks). More...\n\t \n\tnn::os::Tick \tclockSkew\n\t \tClock skew (in ticks). More...\n\t \n\tu32 \tinternalLatency\n\t \tInternal library latency. More...\n\t \n\tu32 \tbufferCount\n\t \tSpecifies the number of packets in the jitter buffer. More...\n\t \n\tu32 \tdropCount\n\t \tSpecifies the number of packets that were dropped. More...\n\t \n\tu32 \tcontinuousDrop\n\t \tNumber of consecutive dropped packets in the most recent frame. More...\n\t \n\tu32 \tjamCount\n\t \tNumber of jammed packets. More...\n\t \n\tu32 \tduplicateCount\n\t \tSpecifies the number of duplicate packets. More...\n\t \n\tu32 \twaitCount\n\t \tNumber of packets on hold due to the loss of the previous packet. More...\n\t \n\tu32 \tlateCount\n\t \tNumber of packets that were late due to network traffic or another reason. More...\n\t \n\tu32 \trecentLateCount\n\t \tNumber of packets that arrived late in the most recent frame. More...\n\t \n\tu32 \trecentReceiveCount\n\t \tNumber of packets that arrived in the most recent frame. More...\n\t \n\tu32 \trecentLateRatio\n\t \tRatio of packets that were late (recentLateCount / recentReceiveCount). More...\n\t \n\tu32 \trecoverCount\n\t \tNumber of recovered packets. More...\n\t \n\tu32 \trecoverUsingSpareCount\n\t \tNumber of packets that were recovered using spare packets. More...\n\t \n\tu32 \tpadding1_\n\t \tRepresents a reserved region. More...\n\t \nDetailed Description\nStores information related to audio.\nField Documentation\n \tu32 bufferCount\nSpecifies the number of packets in the jitter buffer.\n \tnn::os::Tick bufferLatency\nLatency of the jitter buffer.\n \tnn::os::Tick clockSkew\nClock skew (in ticks).\n \tVCTCodec codec\nSpecifies the audio codec of the peer.\n \tu32 continuousDrop\nNumber of consecutive dropped packets in the most recent frame.\n \tu32 dropCount\nSpecifies the number of packets that were dropped.\n \tu32 duplicateCount\nSpecifies the number of duplicate packets.\n \tu32 internalLatency\nInternal library latency.\n \tu32 jamCount\nNumber of jammed packets.\n \tnn::os::Tick jitter\nMaximum jitter (in ticks).\n \tu32 lateCount\nNumber of packets that were late due to network traffic or another reason.\n \tu8 padding0_[3]\nRepresents a reserved region.\n \tu32 padding1_\nRepresents a reserved region.\n \tu32 recentLateCount\nNumber of packets that arrived late in the most recent frame.\n \tu32 recentLateRatio\nRatio of packets that were late (recentLateCount / recentReceiveCount).\n \tu32 recentReceiveCount\nNumber of packets that arrived in the most recent frame.\n \tu32 recoverCount\nNumber of recovered packets.\n \tu32 recoverUsingSpareCount\nNumber of packets that were recovered using spare packets.\n \tu32 sequence\nSequence number of the current audio packet.\n \tu32 waitCount\nNumber of packets on hold due to the loss of the previous packet.\n",1]
,["external.html?file=../../../API/html/struct_v_c_t_config.html","CTR-VCT: VCTConfig Struct Reference",
"Stores initialization parameters for the VCT library. More...\nThe documentation for this struct was generated from the following file:\tinclude/mw/vct/vct.h\n\tData Fields\n\tVCTSession * \tsession\n\t \tSpecifies the region to save the VCTSession structure in. More...\n\t \n\tu32 \tnumSession\n\t \tSpecifies the size of the region specified in session. More...\n\t \n\tVCTMode \tmode\n\t \tSpecifies the chat mode (always specify VCT_MODE_CONFERENCE). More...\n\t \n\tVCTECMode \tecMode\n\t \tSpecifies the operation mode of echo cancellation. More...\n\t \n\tu16 \tcid\n\t \tSpecifies the CID of the client. More...\n\t \n\tu8 \tcodec\n\t \tSpecifies the codec for the main packets (always specify VCT_CODEC_4BIT_ADPCM). More...\n\t \n\tu8 \tframeLength\n\t \tSpecifies the audio frame length in milliseconds. More...\n\t \n\tu8 \tflag\n\t \tEnables or disables VAD, spare packets, drop recovery, and high-pass filter features. More...\n\t \n\tu8 \t_padding1_\n\t \tRepresents a reserved region. More...\n\t \n\tvoid * \taudioBuffer\n\t \tSpecifies the receive buffer for the audio stream (requires 32-byte alignment). More...\n\t \n\tu32 \taudioBufferSize\n\t \tSpecifies the size of the buffer specified in audioBuffer. More...\n\t \n\tVCTEventCallback \tcallback\n\t \tSpecifies the event callback function. More...\n\t \n\tVCTSendCallback \tsendCallback\n\t \tSpecifies the send callback function. More...\n\t \n\tvoid * \tuserData\n\t \tSpecifies the user data to pass when calling the callback function. More...\n\t \nDetailed Description\nStores initialization parameters for the VCT library.\nSee Also\n\tVCT_Init\nRevision History:\n\t2011/10/21 Added the ecMode member to specify the operation mode of echo cancellation.\nField Documentation\n \tu8 _padding1_\nRepresents a reserved region.\n \tvoid* audioBuffer\nSpecifies the receive buffer for the audio stream (requires 32-byte alignment).\n \tu32 audioBufferSize\nSpecifies the size of the buffer specified in audioBuffer.\n \tVCTEventCallback callback\nSpecifies the event callback function.\n \tu16 cid\nSpecifies the CID of the client.\n \tu8 codec\nSpecifies the codec for the main packets (always specify VCT_CODEC_4BIT_ADPCM).\n \tVCTECMode ecMode\nSpecifies the operation mode of echo cancellation.\n \tu8 flag\nEnables or disables VAD, spare packets, drop recovery, and high-pass filter features.\n \tu8 frameLength\nSpecifies the audio frame length in milliseconds.\n \tVCTMode mode\nSpecifies the chat mode (always specify VCT_MODE_CONFERENCE).\n \tu32 numSession\nSpecifies the size of the region specified in session.\n \tVCTSendCallback sendCallback\nSpecifies the send callback function.\n \tVCTSession* session\nSpecifies the region to save the VCTSession structure in.\n \tvoid* userData\nSpecifies the user data to pass when calling the callback function.\n",1]
,["external.html?file=../../../API/html/struct_v_c_t_session.html","CTR-VCT: VCTSession Struct Reference",
"Defines the structure for a session. Used for managing CIDs and the session state. More...\nThe documentation for this struct was generated from the following file:\tinclude/mw/vct/vct.h\n\tData Fields\n\tVCTMode \tmode\n\t \tChat mode in this session. More...\n\t \n\tu8 \t_padding0_\n\t \tRepresents a reserved region. More...\n\t \n\tu16 \tcid\n\t \tRemote CID. More...\n\t \n\tu16 \t_padding1_\n\t \tRepresents a reserved region. More...\n\t \n\tu16 \tcidList [16]\n\t \tList of client CIDs in conference mode. More...\n\t \n\tVCTState \tstate\n\t \tState of this session. More...\n\t \n\tu8 \t_padding2_\n\t \tRepresents a reserved region. More...\n\t \n\tvoid * \tuserData\n\t \tUser data. More...\n\t \n\tVCTSession * \t_next\n\t \nDetailed Description\nDefines the structure for a session. Used for managing CIDs and the session state.\nSee Also\n\tVCTConfig\nField Documentation\n \tVCTSession* _next\n \tu8 _padding0_\nRepresents a reserved region.\n \tu16 _padding1_\nRepresents a reserved region.\n \tu8 _padding2_\nRepresents a reserved region.\n \tu16 cid\nRemote CID.\n \tu16 cidList[16]\nList of client CIDs in conference mode.\n \tVCTMode mode\nChat mode in this session.\n \tVCTState state\nState of this session.\n \tvoid* userData\nUser data.\n",1]
,["external.html?file=../../../API/html/vct_8h.html","CTR-VCT: include/mw/vct/vct.h File Reference",
"Go to the source code of this file.\n\tStructures\n\tstruct  \tVCTAudioInfo\n\t \tStores information related to audio. More...\n\t \n\tstruct  \tVCTSession\n\t \tDefines the structure for a session. Used for managing CIDs and the session state. More...\n\t \n\tstruct  \tVCTConfig\n\t \tStores initialization parameters for the VCT library. More...\n\t \n\tMacros\n\t#define \tVCT_ERROR_NONE   0\n\t \n\t#define \tVCT_ERROR_BAD_PARAM   -1\n\t \n\t#define \tVCT_ERROR_BAD_MODE   -2\n\t \n\t#define \tVCT_ERROR_BAD_REQUEST   -3\n\t \n\t#define \tVCT_ERROR_SEND_FAIL   -4\n\t \n\t#define \tVCT_ERROR_EXHAUST_CLIENTS   -6\n\t \n\t#define \tVCT_MAX_SESSION   16\n\t \n\t#define \tVCT_MAX_CONFERENCE_CLIENT   16\n\t \n\t#define \tVCT_MAX_CLIENT   16\n\t \n\t#define \tVCT_MAX_AUDIO_STREAM   (VCT_MAX_CONFERENCE_CLIENT - 1)\n\t \n\t#define \tVCT_MAGIC_PACKET_HEADER   0x5f564354\n\t \tMagic number in the VCT packet header. More...\n\t \n\t#define \tVCT_CODEC_DEFAULT   VCT_CODEC_4BIT_ADPCM\n\t \tDefault audio codec. More...\n\t \n\t#define \tVCT_SPARE_CODEC_DEFAULT   VCT_CODEC_2BIT_ADPCM\n\t \tDefault audio codec for spare packets. More...\n\t \n\t#define \tVCT_AUDIO_FRAME_LENGTH_MIN   64\n\t \tSpecifies the minimum audio frame length (in milliseconds). More...\n\t \n\t#define \tVCT_AUDIO_FRAME_LENGTH_MAX   192\n\t \tSpecifies the maximum audio frame length (in milliseconds). More...\n\t \n\t#define \tVCT_AUDIO_FRAME_LENGTH_DEFAULT   144\n\t \tSpecifies the default audio frame length (in milliseconds). More...\n\t \n\t#define \tVCT_AUDIO_DATA_SIZE_PER_MILLI_SEC   16\n\t \n\t#define \tVCT_AUDIO_DATA_SIZE_MIN   (VCT_AUDIO_FRAME_LENGTH_MIN * VCT_AUDIO_DATA_SIZE_PER_MILLI_SEC)\n\t \n\t#define \tVCT_AUDIO_DATA_SIZE_MAX   (VCT_AUDIO_FRAME_LENGTH_MAX * VCT_AUDIO_DATA_SIZE_PER_MILLI_SEC)\n\t \n\t#define \tVCT_AUDIO_DATA_SIZE_DEFAULT   (VCT_AUDIO_FRAME_LENGTH_DEFAULT * VCT_AUDIO_DATA_SIZE_PER_MILLI_SEC)\n\t \n\t#define \tVCT_AUDIO_FRAME_RATE   8000\n\t \tAudio frame rate (8 kHz). More...\n\t \n\t#define \tVCT_AUDIO_HEADER_SIZE   12\n\t \tHeader size for VCT audio data packets. More...\n\t \n\t#define \tVCT_AUDIO_2_BIT_ADPCM_PACKET_SIZE_MAX   (VCT_AUDIO_HEADER_SIZE + 2 * VCT_AUDIO_FRAME_LENGTH_MAX + 4)\n\t \n\t#define \tVCT_AUDIO_3_BIT_ADPCM_PACKET_SIZE_MAX   (VCT_AUDIO_HEADER_SIZE + 3 * VCT_AUDIO_FRAME_LENGTH_MAX + 4)\n\t \n\t#define \tVCT_AUDIO_4_BIT_ADPCM_PACKET_SIZE_MAX   (VCT_AUDIO_HEADER_SIZE + 4 * VCT_AUDIO_FRAME_LENGTH_MAX + 4)\n\t \n\t#define \tVCT_AUDIO_SPARE_PACKET_SIZE_MAX   VCT_AUDIO_2_BIT_ADPCM_PACKET_SIZE_MAX\n\t \n\t#define \tVCT_AUDIO_PACKET_BUFFER_SIZE   (VCT_AUDIO_DATA_SIZE_MAX + VCT_AUDIO_SPARE_PACKET_SIZE_MAX)\n\t \n\t#define \tVCT_AUDIO_BUFFER_PACKET_HEADER   56\n\t \n\t#define \tVCT_AUDIO_BUFFER_SIZE   (VCT_AUDIO_PACKET_BUFFER_SIZE + VCT_AUDIO_BUFFER_PACKET_HEADER)\n\t \n\t#define \tVCT_DEFAULT_AUDIO_BUFFER_COUNT   8\n\t \n\t#define \tVCT_MIN_AUDIO_BUFFER_COUNT   4\n\t \n\t#define \tVCT_MAX_AUDIO_BUFFER_COUNT   (24 * VCT_MAX_AUDIO_STREAM)\n\t \n\t#define \tVCT_DEFAULT_AUDIO_BUFFER_SIZE\n\t \n\t#define \tVCT_VAD_DETECT_GAIN_UP_DEFAULT   350\n\t \n\t#define \tVCT_VAD_LOST_GAIN_UP_DEFAULT   280\n\t \n\t#define \tVCT_VAD_INVALID_SCALE_THRESHOLD_DEFAULT   (7 * 7)\n\t \n\t#define \tVCT_VAD_CLAMP_GAIN_MAX   0x3FFFFFFF\n\t \n\t#define \tVCT_VAD_RELEASE_TIME_DEFAULT   5\n\t \n\t#define \tVCT_CONFIG_FLAG_NONE   0x00\n\t \n\t#define \tVCT_CONFIG_FLAG_VAD   0x01\n\t \tVAD (Voice Activity Detection) feature. More...\n\t \n\t#define \tVCT_CONFIG_FLAG_ECHO_CANCEL   0x02\n\t \tEcho cancellation. More...\n\t \n\t#define \tVCT_CONFIG_FLAG_HPF   0x04\n\t \tHigh-pass filter. More...\n\t \n\t#define \tVCT_CONFIG_FLAG_SPARE_PACKET   0x08\n\t \tSpare packet. More...\n\t \n\t#define \tVCT_CONFIG_FLAG_DROP_RECOVER   0x20\n\t \tDrop recovery. More...\n\t \n\t#define \tVCT_CONFIG_FLAG_BPF   0x40\n\t \tBiquad filter. More...\n\t \n\t#define \tVCT_CONFIG_FLAG_ALL   0xff\n\t \n\t#define \tVCT_CONFIG_FLAG_DEFAULT\n\t \n\tTypedefs\n\ttypedef struct VCTSession_ \tVCTSession\n\t \n\ttypedef void(* \tVCTEventCallback )(u16 cid, VCTEvent result, VCTSession *session, void *param)\n\t \tDefines the type for an event callback. More...\n\t \n\ttypedef bool(* \tVCTSendCallback )(u16 cid, const void *buff, u32 size, bool isReliable)\n\t \tDefines the type for a send callback. More...\n\t \n\tEnumerations\n\tenum  \tVCTMode {   VCT_MODE_NULL,   VCT_MODE_CONFERENCE }\n\t \n\tenum  \tVCTState {   VCT_STATE_INIT,   VCT_STATE_TALKING }\n\t \tEnumerates session states. More...\n\t \n\tenum  \tVCTEvent {   VCT_EVENT_NONE,   VCT_EVENT_CONNECTED,   VCT_EVENT_DISCONNECTED }\n\t \tEnumerates voice chat library events. More...\n\t \n\tenum  \tVCTCodec {   VCT_CODEC_8BIT_RAW,   VCT_CODEC_G711_ULAW,   VCT_CODEC_2BIT_ADPCM,   VCT_CODEC_3BIT_ADPCM,   VCT_CODEC_4BIT_ADPCM,   VCT_CODEC_END }\n\t \tEnumerates audio codecs. More...\n\t \n\tenum  \tVCTECMode {   VCT_EC_STANDARD,   VCT_EC_HIGHPERFORMANCE }\n\t \tEnumerates echo cancellation modes. More...\n\t \n\tFunctions\n\tbool \tVCT_DeleteSession (VCTSession *session)\n\t \tDeletes the specified session. More...\n\t \n\ts32 \tVCT_AddConferenceClient (u16 cid)\n\t \tAdds a client to the conference. More...\n\t \n\ts32 \tVCT_RemoveConferenceClient (u16 cid)\n\t \tRemoves a client from the conference. More...\n\t \n\tbool \tVCT_OnConferenceClient (u16 cid)\n\t \tReturns whether a client is in the conference. More...\n\t \n\tInitialization and Finalization\n\tbool \tVCT_Init (VCTConfig *config)\n\t \tThis function initializes the VCT library. More...\n\t \n\tbool \tVCT_IsInitialized (void)\n\t \tChecks whether the VCT library is finished being initialized. More...\n\t \n\tvoid \tVCT_Cleanup (void)\n\t \tFinalizes the VCT library. More...\n\t \n\tvoid \tVCT_Main (void)\n\t \tThis function runs the main loop of the VCT library. More...\n\t \n\tPer-frame Execution\n\tbool \tVCT_HandleData (u16 cid, u8 *buffer, u32 size)\n\t \tProcesses voice chat data. More...\n\t \n\tAudio Streaming\n\tbool \tVCT_StartStreaming (const VCTSession *session)\n\t \tStarts audio streaming. More...\n\t \n\tvoid \tVCT_ClearStreaming (const VCTSession *session)\n\t \tClears audio streaming. More...\n\t \n\tvoid \tVCT_StopStreaming (const VCTSession *session)\n\t \tStops audio streaming. More...\n\t \n\tbool \tVCT_SendAudioEx (const void *audio_data, u32 micScale, u32 micOffset)\n\t \tQueues audio data in the send queue. More...\n\t \n\tbool \tVCT_ReceiveAudio (void *audio_data, u32 length, u16 outCIDList[])\n\t \tExtracts audio data from the receive buffer. More...\n\t \n\tbool \tVCT_SetCodec (VCTCodec codec)\n\t \tSets the audio codec. More...\n\t \n\tVCTCodec \tVCT_GetCodec (void)\n\t \tGets the currently configured audio codec. More...\n\t \n\tbool \tVCT_IsValidCodec (VCTCodec codec)\n\t \tDetermines whether the main packet audio codec type specified by codec is usable. More...\n\t \n\tbool \tVCT_SetAudioFrameLength (u32 frameLength)\n\t \tSets the audio frame length. More...\n\t \n\tu32 \tVCT_GetAudioFrameLength (void)\n\t \tGets the currently configured audio frame length. More...\n\t \n\tu32 \tVCT_GetAudioDataSize (void)\n\t \tGets the packet size of audio data. More...\n\t \n\tu32 \tVCT_GetAudioScale (const void *audio, u32 length)\n\t \tGets the calculated audio scale (square of the average power) of the input audio data. More...\n\t \n\tvoid \tVCT_GetAudioInfoFromCid (u16 cid, VCTAudioInfo *info)\n\t \tGets audio streaming information for the party specified by cid. More...\n\t \n\tNoise Skipping\n\tvoid \tVCT_SetNoiseSkipTime (u32 count)\n\t \tSets the length of time for which sound is not sent in VCT_SignalNoiseSkip. More...\n\t \n\tu32 \tVCT_GetNoiseSkipTime (void)\n\t \tReturns the length of time for which sound is not sent in VCT_SignalNoiseSkip. More...\n\t \n\tvoid \tVCT_SignalNoiseSkip (void)\n\t \tWhen VAD is enabled and not active, this function makes VAD active on the sound of button presses so that audio is not sent. More...\n\t \n\tSpare Packets\n\tvoid \tVCT_EnableSparePacket (bool flag)\n\t \tThis function enables and disables the spare packet feature. More...\n\t \n\tbool \tVCT_IsEnableSparePacket (void)\n\t \tThis function gets whether the spare packet feature is enabled or disabled. More...\n\t \n\tbool \tVCT_SetSpareCodec (VCTCodec spareCodec)\n\t \tSets the audio codec for spare packets. More...\n\t \n\tVCTCodec \tVCT_GetSpareCodec (void)\n\t \tGets the currently configured audio codec for spare packets. More...\n\t \n\tbool \tVCT_IsValidSpareCodec (VCTCodec codec)\n\t \tDetermines whether you can use the codec type specified by codec as a spare-packet codec type. More...\n\t \n\tVAD\n\tvoid \tVCT_EnableVAD (bool flag)\n\t \tEnables or disables the VAD feature. More...\n\t \n\tbool \tVCT_IsEnableVAD (void)\n\t \tGets whether the VAD feature is enabled. More...\n\t \n\tbool \tVCT_GetVADActivity (void)\n\t \tVAD Gets the audio detection results from the VAD algorithm. More...\n\t \n\tvoid \tVCT_ResetVAD (void)\n\t \tResets the internal VAD status. More...\n\t \n\tvoid \tVCT_SetVADActiveGain (u16 value)\n\t \tSets the speech frame detection threshold. More...\n\t \n\tu16 \tVCT_GetVADActiveGain (void)\n\t \tGets the current speech frame detection threshold. More...\n\t \n\tvoid \tVCT_SetVADInactiveGain (u16 value)\n\t \tSets the silent frame detection threshold. More...\n\t \n\tu16 \tVCT_GetVADInactiveGain (void)\n\t \tGets the current silent frame detection threshold. More...\n\t \n\tvoid \tVCT_SetVADReleaseTime (u32 count)\n\t \tSets the time that must elapse after silence is detected before packet transmission is stopped. More...\n\t \n\tu32 \tVCT_GetVADReleaseTime (void)\n\t \tGets the time that must elapse after silence is detected before packet transmission is stopped. More...\n\t \n\tvoid \tVCT_SetVADClampGain (u32 value)\n\t \tSets the volume threshold as a volume scale value (the square of the average power) for unconditionally determining silence. More...\n\t \n\tu32 \tVCT_GetVADClampGain (void)\n\t \tGets the volume threshold as a volume scale value for unconditionally determining silence. More...\n\t \n\tEcho Canceler\n\tvoid \tVCT_HandleReference (const u8 *buffer, u32 size)\n\t \tSupplies reference data for the echo canceler. More...\n\t \nMacro Definition Documentation\n \t#define VCT_AUDIO_2_BIT_ADPCM_PACKET_SIZE_MAX   (VCT_AUDIO_HEADER_SIZE + 2 * VCT_AUDIO_FRAME_LENGTH_MAX + 4)\n \t#define VCT_AUDIO_3_BIT_ADPCM_PACKET_SIZE_MAX   (VCT_AUDIO_HEADER_SIZE + 3 * VCT_AUDIO_FRAME_LENGTH_MAX + 4)\n \t#define VCT_AUDIO_4_BIT_ADPCM_PACKET_SIZE_MAX   (VCT_AUDIO_HEADER_SIZE + 4 * VCT_AUDIO_FRAME_LENGTH_MAX + 4)\n \t#define VCT_AUDIO_BUFFER_PACKET_HEADER   56\n \t#define VCT_AUDIO_BUFFER_SIZE   (VCT_AUDIO_PACKET_BUFFER_SIZE + VCT_AUDIO_BUFFER_PACKET_HEADER)\n \t#define VCT_AUDIO_DATA_SIZE_DEFAULT   (VCT_AUDIO_FRAME_LENGTH_DEFAULT * VCT_AUDIO_DATA_SIZE_PER_MILLI_SEC)\n \t#define VCT_AUDIO_DATA_SIZE_MAX   (VCT_AUDIO_FRAME_LENGTH_MAX * VCT_AUDIO_DATA_SIZE_PER_MILLI_SEC)\n \t#define VCT_AUDIO_DATA_SIZE_MIN   (VCT_AUDIO_FRAME_LENGTH_MIN * VCT_AUDIO_DATA_SIZE_PER_MILLI_SEC)\n \t#define VCT_AUDIO_DATA_SIZE_PER_MILLI_SEC   16\n \t#define VCT_AUDIO_FRAME_LENGTH_DEFAULT   144\nSpecifies the default audio frame length (in milliseconds).\n \t#define VCT_AUDIO_FRAME_LENGTH_MAX   192\nSpecifies the maximum audio frame length (in milliseconds).\n \t#define VCT_AUDIO_FRAME_LENGTH_MIN   64\nSpecifies the minimum audio frame length (in milliseconds).\n \t#define VCT_AUDIO_FRAME_RATE   8000\nAudio frame rate (8 kHz).\n \t#define VCT_AUDIO_HEADER_SIZE   12\nHeader size for VCT audio data packets.\n \t#define VCT_AUDIO_PACKET_BUFFER_SIZE   (VCT_AUDIO_DATA_SIZE_MAX + VCT_AUDIO_SPARE_PACKET_SIZE_MAX)\n \t#define VCT_AUDIO_SPARE_PACKET_SIZE_MAX   VCT_AUDIO_2_BIT_ADPCM_PACKET_SIZE_MAX\n \t#define VCT_CODEC_DEFAULT   VCT_CODEC_4BIT_ADPCM\nDefault audio codec.\n \t#define VCT_CONFIG_FLAG_ALL   0xff\n \t#define VCT_CONFIG_FLAG_BPF   0x40\nBiquad filter.\n \t#define VCT_CONFIG_FLAG_DEFAULT\nValue:(VCT_CONFIG_FLAG_VAD | \\\n VCT_CONFIG_FLAG_ECHO_CANCEL | \\\n VCT_CONFIG_FLAG_SPARE_PACKET | \\\n VCT_CONFIG_FLAG_DROP_RECOVER)\n \t#define VCT_CONFIG_FLAG_DROP_RECOVER   0x20\nDrop recovery.\n \t#define VCT_CONFIG_FLAG_ECHO_CANCEL   0x02\nEcho cancellation.\n \t#define VCT_CONFIG_FLAG_HPF   0x04\nHigh-pass filter.\n \t#define VCT_CONFIG_FLAG_NONE   0x00\n \t#define VCT_CONFIG_FLAG_SPARE_PACKET   0x08\nSpare packet.\n \t#define VCT_CONFIG_FLAG_VAD   0x01\nVAD (Voice Activity Detection) feature.\n \t#define VCT_DEFAULT_AUDIO_BUFFER_COUNT   8\n \t#define VCT_DEFAULT_AUDIO_BUFFER_SIZE\nValue:(VCT_AUDIO_BUFFER_SIZE \\\n * VCT_DEFAULT_AUDIO_BUFFER_COUNT \\\n * VCT_MAX_AUDIO_STREAM)\n \t#define VCT_ERROR_BAD_MODE   -2\n \t#define VCT_ERROR_BAD_PARAM   -1\n \t#define VCT_ERROR_BAD_REQUEST   -3\n \t#define VCT_ERROR_EXHAUST_CLIENTS   -6\n \t#define VCT_ERROR_NONE   0\n \t#define VCT_ERROR_SEND_FAIL   -4\n \t#define VCT_MAGIC_PACKET_HEADER   0x5f564354\nMagic number in the VCT packet header.\n \t#define VCT_MAX_AUDIO_BUFFER_COUNT   (24 * VCT_MAX_AUDIO_STREAM)\n \t#define VCT_MAX_AUDIO_STREAM   (VCT_MAX_CONFERENCE_CLIENT - 1)\n \t#define VCT_MAX_CLIENT   16\n \t#define VCT_MAX_CONFERENCE_CLIENT   16\n \t#define VCT_MAX_SESSION   16\n \t#define VCT_MIN_AUDIO_BUFFER_COUNT   4\n \t#define VCT_SPARE_CODEC_DEFAULT   VCT_CODEC_2BIT_ADPCM\nDefault audio codec for spare packets.\n \t#define VCT_VAD_CLAMP_GAIN_MAX   0x3FFFFFFF\n \t#define VCT_VAD_DETECT_GAIN_UP_DEFAULT   350\n \t#define VCT_VAD_INVALID_SCALE_THRESHOLD_DEFAULT   (7 * 7)\n \t#define VCT_VAD_LOST_GAIN_UP_DEFAULT   280\n \t#define VCT_VAD_RELEASE_TIME_DEFAULT   5\nTypedef Documentation\n \ttypedef void(* VCTEventCallback)(u16 cid, VCTEvent result, VCTSession *session, void *param)\nDefines the type for an event callback.\nSee Also\n\tVCTConfig, VCTSendCallback\n \ttypedef bool(* VCTSendCallback)(u16 cid, const void *buff, u32 size, bool isReliable)\nDefines the type for a send callback.\nSee Also\n\tVCTConfig, VCTEventCallback\n \ttypedef struct VCTSession_ VCTSession\nEnumeration Type Documentation\n \tenum VCTCodec\nEnumerates audio codecs.\n\tEnumerator\n\tVCT_CODEC_8BIT_RAW \tSpecifies 8-bit 8 kHz raw audio.\n\tVCT_CODEC_G711_ULAW \tSpecifies G711 u-Law.\n\tVCT_CODEC_2BIT_ADPCM \tSpecifies 2-bit IMA-ADPCM (non-standard).\n\tVCT_CODEC_3BIT_ADPCM \tSpecifies 3-bit IMA-ADPCM.\n\tVCT_CODEC_4BIT_ADPCM \tSpecifies 4-bit IMA-ADPCM.\n\tVCT_CODEC_END \t\n \tenum VCTECMode\nEnumerates echo cancellation modes.\n\tEnumerator\n\tVCT_EC_STANDARD \tSpecifies standard echo cancellation.\n\tVCT_EC_HIGHPERFORMANCE \tSpecifies high-performance echo cancellation (only available in debug mode).\n \tenum VCTEvent\nEnumerates voice chat library events.\n\tEnumerator\n\tVCT_EVENT_NONE \t\n\tVCT_EVENT_CONNECTED \tConnected to the remote client.\n\tVCT_EVENT_DISCONNECTED \tDisconnected.\n \tenum VCTMode\n\tEnumerator\n\tVCT_MODE_NULL \t\n\tVCT_MODE_CONFERENCE \tConference mode.\n \tenum VCTState\nEnumerates session states.\n\tEnumerator\n\tVCT_STATE_INIT \tSpecifies an initialized state.\n\tVCT_STATE_TALKING \tSpecifies that the peers are talking.\nFunction Documentation\n \ts32 VCT_AddConferenceClient \t( \tu16  \tcid\t) \t\nAdds a client to the conference.\nOne's own connection ID does not need to be specified. (It is ignored internally by the function even if it is specified.) To start a conference, this function must be called by all parties for each other. For example, for three systems with the connection IDs 1, 2, and 3 to start a conference, system 1 must add 2 and 3, system 2 must add 1 and 3, and system 3 must add 1 and 2.\nIf N is the maximum number of people who can connect in a conference, the maximum number of clients that the local system can add to a conference is N - 1. Before adding clients you must use the VCT_Init function to specify x number of VCTSession structures, where x = (total number of participants - 1). If there are not enough sessions, the function returns an error.\nAn error also occurs if this function is called and the mode is not VCT_MODE_CONFERENCE.\nParameters\n\t \t[in]\tcid\tThe connection ID of the client being added.\nReturn values\n\t \t0\tIndicates that the connection ID of the client was added successfully.\n \tNegative\tThe error code when adding the connection ID of the client failed.\nRevision History:\n\t2013/06/11 Fixed a mistake in the description of the return value.\n2011/08/31 Initial version.\n \tvoid VCT_Cleanup \t( \tvoid  \t\t) \t\nFinalizes the VCT library.\nCall this function when finalizing VoiceChat or changing the operation mode (VCTMode).\nRevision History:\n\t2011/08/31 Initial version.\n \tvoid VCT_ClearStreaming \t( \tconst VCTSession *  \tsession\t) \t\nClears audio streaming.\nParameters\n\t \t[in]\tsession\tThe session for which to clear streaming.\nRevision History:\n\t2013/02/15 Initial version.\n \tbool VCT_DeleteSession \t( \tVCTSession *  \tsession\t) \t\nDeletes the specified session.\nParameters\n\t \t[in]\tsession\tThe VCTSession structure to delete.\nReturn values\n\t \ttrue\tDeletion succeeded.\n \tfalse\tDeletion failed.\nRevision History:\n\t2011/08/31 Initial version.\n \tvoid VCT_EnableSparePacket \t( \tbool  \tflag\t) \t\nThis function enables and disables the spare packet feature.\nThe spare packet feature is enabled by default.\nParameters\n\t \t[in]\tflag\tSpecify true to enable or false to disable.\nRevision History:\n\t2011/08/31 Initial version.\n \tvoid VCT_EnableVAD \t( \tbool  \tflag\t) \t\nEnables or disables the VAD feature.\nThe VAD feature is enabled by default.\nWhen VAD is enabled, in addition to evaluating audio inside the VCT_Main function, decisions are also made automatically about whether to send packets.\nParameters\n\t \t[in]\tflag\tSpecify true to enable or false to disable.\nRevision History:\n\t2011/08/31 Initial version.\n \tu32 VCT_GetAudioDataSize \t( \tvoid  \t\t) \t\nGets the packet size of audio data.\nThis function returns the data size calculated based on the currently configured audio frame length. You can use the VCT_GetAudioFrameLength function to get the currently set audio frame length.\nIf you call this function before initialization, the data size VCT_AUDIO_DATA_SIZE_DEFAULT corresponding to the recommended audio frame length VCT_AUDIO_FRAME_LENGTH_DEFAULT is returned.\nReturn values\n\t \tu32\tPacket size of audio data.\nRevision History:\n\t2011/08/31 Initial version.\n \tu32 VCT_GetAudioFrameLength \t( \tvoid  \t\t) \t\nGets the currently configured audio frame length.\nReturns the value set in the frameLength member of the VCTConfig structure at time of initialization, or the value set by the VCT_SetAudioFrameLength function after initialization.\nIf you call this function before initialization, the recommended value VCT_AUDIO_FRAME_LENGTH_DEFAULT is returned.\nReturn values\n\t \ttrue\tConfiguration succeeded.\n \tfalse\tConfiguration failed.\nRevision History:\n\t2011/08/31 Initial version.\n \tvoid VCT_GetAudioInfoFromCid \t( \tu16  \tcid,\n \t \t \tVCTAudioInfo *  \tinfo \n \t \t) \t\t\nGets audio streaming information for the party specified by cid.\nParameters\n\t \t[in]\tcid\tThe connection ID of the other party from which to get audio streaming information.\n \t[in]\tinfo\tPointer to an VCTAudioInfo structure.\nRevision History:\n\t2011/08/31 Initial version.\n \tu32 VCT_GetAudioScale \t( \tconst void *  \taudio,\n \t \t \tu32  \tlength \n \t \t) \t\t\nGets the calculated audio scale (square of the average power) of the input audio data.\nBefore using the VCT_SendAudioEx function, use this function to get the volume scale value of the input audio data.\nThe length argument specifies the number of bytes of audio data to input. The audio data must have been sampled at 16 bits/8 kHz.\nParameters\n\t \t[in]\taudio\tSpecifies the audio data.\n \t[in]\tlength\tSpecifies the number of bytes of the audio data.\nReturn values\n\t \ttrue\tThe received data is VoiceChat data.\nRevision History:\n\t2012/04/19 - Corrected the description of the length argument by changing \"number of samples\" to \"number of bytes.\"\n2011/09/29 - Clarified that the audio variable is const.\n2011/08/31 Initial version.\n \tVCTCodec VCT_GetCodec \t( \tvoid  \t\t) \t\nGets the currently configured audio codec.\nUse the VCT_GetSpareCodec function to get the audio codec type for spare packets.\nReturn values\n\t \t@ref\tVCTCodec The audio codec that is currently set for the main packet.\nRevision History:\n\t2011/08/31 Initial version.\n \tu32 VCT_GetNoiseSkipTime \t( \tvoid  \t\t) \t\nReturns the length of time for which sound is not sent in VCT_SignalNoiseSkip.\nReturn values\n\t \tu32\tThe length of time for which sound is not sent (in milliseconds).\nRevision History:\n\t2012/03/01 Initial version.\n \tVCTCodec VCT_GetSpareCodec \t( \tvoid  \t\t) \t\nGets the currently configured audio codec for spare packets.\nThis value is meaningless if the spare packet feature is not used.\nNote: The only codec type supported for spare packets is 2-bit ADPCM. At the present time, this function always returns VCT_CODEC_2BIT_ADPCM.\nReturn values\n\t \t@ref\tVCTCodec The currently set codec type for spare packets.\nRevision History:\n\t2011/08/31 Initial version.\n \tu16 VCT_GetVADActiveGain \t( \tvoid  \t\t) \t\nGets the current speech frame detection threshold.\nReturn values\n\t \tu16\tThreshold for detecting a speech frame.\nRevision History:\n\t2011/08/31 Initial version.\n \tbool VCT_GetVADActivity \t( \tvoid  \t\t) \t\nVAD Gets the audio detection results from the VAD algorithm.\nReturns true while audio is detected in the frame (speech frame) and false while it is not (silent frame).\nAlways returns false while the VAD feature is disabled, regardless of the presence of speech.\nReturn values\n\t \ttrue\tSpecifies that audio is present.\n \tfalse\tSpecifies that no audio is present.\nRevision History:\n\t2011/08/31 Initial version.\n \tu32 VCT_GetVADClampGain \t( \tvoid  \t\t) \t\nGets the volume threshold as a volume scale value for unconditionally determining silence.\nThe volume scale value is specified in the range from 0 through 0x3FFFFFFF.\nReturn values\n\t \tu32\tThe volume threshold at which a frame is unconditionally determined to be silent.\nRevision History:\n\t2011/08/31 Initial version.\n \tu16 VCT_GetVADInactiveGain \t( \tvoid  \t\t) \t\nGets the current silent frame detection threshold.\nReturn values\n\t \tu16\tThreshold for detecting a silent frame.\nRevision History:\n\t2011/08/31 Initial version.\n \tu32 VCT_GetVADReleaseTime \t( \tvoid  \t\t) \t\nGets the time that must elapse after silence is detected before packet transmission is stopped.\nReturn values\n\t \tu32\tRelease time (in number of packets).\nRevision History:\n\t2011/08/31 Initial version.\n \tbool VCT_HandleData \t( \tu16  \tcid,\n \t \t \tu8 *  \tbuffer,\n \t \t \tu32  \tsize \n \t \t) \t\t\nProcesses voice chat data.\nPass the data received by the communications library to this function.\nNote\n\tIf the return value is true (that is, the received data is voice chat data), no additional processing is necessary because the callback function specified in the callback member variable of the VCTConfig structure is called from this function. If the return value is false, the received data is something other than voice chat data (game data, for example), and you must implement some means for the application to perform the necessary processing on the data.\nParameters\n\t \t[in]\tcid\tConnectionID of the data sender.\n \t[in]\tbuffer\tPointer to the start of the received data.\n \t[in]\tsize\tThe size of the received data. This value is in bytes.\nReturn values\n\t \ttrue\tThe passed data is voice chat data.\n \tfalse\tEither the passed data is voice chat data, or the VCT library is not initialized.\nRevision History:\n\t2013/06/07 Revised the description.\n2011/08/31 Initial version.\n \tvoid VCT_HandleReference \t( \tconst u8 *  \tbuffer,\n \t \t \tu32  \tsize \n \t \t) \t\t\nSupplies reference data for the echo canceler.\nCall the nn::snd::GetMixedBusData function at every sound DSP interrupt (every 5 ms), and pass the 5 ms of 16 bit/32 kHz/stereo data obtained by that function to the buffer of this function.\nThis function does nothing if size is not the correct size for 5 milliseconds of 16-bit/32-kHz stereo data.\nParameters\n\t \t[in]\tbuffer\tReference data for the echo canceler.\n \t[in]\tsize\tThe size of the reference data for the echo canceler.\nRevision History:\n\t2011/09/29 - Clarified that the buffer variable is const.\n2011/08/31 Initial version.\n \tbool VCT_Init \t( \tVCTConfig *  \tconfig\t) \t\nThis function initializes the VCT library.\nParameters\n\t \t[in]\tconfig\tVCTConfig structure.\nReturn values\n\t \ttrue\tInitialization succeeded.\n \tfalse\tInitialization failed.\nRevision History:\n\t2011/08/31 Initial version.\n \tbool VCT_IsEnableSparePacket \t( \tvoid  \t\t) \t\nThis function gets whether the spare packet feature is enabled or disabled.\nThe spare packet feature is enabled by default.\nReturn values\n\t \ttrue\tSpecifies that the spare packet feature is enabled.\n \tfalse\tSpecifies that the spare packet feature is disabled.\nRevision History:\n\t2011/08/31 Initial version.\n \tbool VCT_IsEnableVAD \t( \tvoid  \t\t) \t\nGets whether the VAD feature is enabled.\nReturn values\n\t \ttrue\tSpecifies that the VAD feature is enabled.\n \tfalse\tSpecifies that the VAD feature is disabled.\nRevision History:\n\t2011/08/31 Initial version.\n \tbool VCT_IsInitialized \t( \tvoid  \t\t) \t\nChecks whether the VCT library is finished being initialized.\nReturn values\n\t \ttrue\tAlready initialized.\n \tfalse\tPre-initialized state.\nRevision History:\n\t2011/08/31 Initial version.\n \tbool VCT_IsValidCodec \t( \tVCTCodec  \tcodec\t) \t\nDetermines whether the main packet audio codec type specified by codec is usable.\nParameters\n\t \t[in]\tcodec\tAudio codec type.\nReturn values\n\t \ttrue\tSpecifies that the codec can be used.\n \tfalse\tSpecifies that the codec cannot be used.\nRevision History:\n\t2011/08/31 Initial version.\n \tbool VCT_IsValidSpareCodec \t( \tVCTCodec  \tcodec\t) \t\nDetermines whether you can use the codec type specified by codec as a spare-packet codec type.\nParameters\n\t \t[in]\tcodec\tThe codec type.\nReturn values\n\t \ttrue\tCan be used.\n \tfalse\tCannot be used.\nRevision History:\n\t2011/08/31 Initial version.\n \tvoid VCT_Main \t( \tvoid  \t\t) \t\nThis function runs the main loop of the VCT library.\nSends the audio data queued by VCT_SendAudioEx and decodes the received audio data passed by VCT_HandleData.\nThe process for sending data that takes place inside VCT_Main (the calling of the send callback) must be called a sufficient number of times, so you also need to call VCT_Main a sufficient number of times. If the audio frame length is length ms and there are num number of communication partners, you must call it more than (num * 1000 / length) times each second. For example, if the audio frame length is 144 ms and there are 8 connected systems, the calculation is 7 * 1000 / 144 = 48.6, so you must call it about 50 to 60 times each second. Also, make calls at regular intervals rather than all at once whenever possible, because audio processing is performed at regular intervals. For example, call it a sufficient number of times in each game frame.\nRevision History:\n\t2013/06/07 Added a description of the number of times to call VCT_Main.\n2011/08/31 Initial version.\n \tbool VCT_OnConferenceClient \t( \tu16  \tcid\t) \t\nReturns whether a client is in the conference.\nParameters\n\t \t[in]\tcid\tThe connection ID of the client to check for membership in the conference.\nReturn values\n\t \ttrue\tParticipating.\n \tfalse\tNot a member.\nRevision History:\n\t2011/08/31 Initial version.\n \tbool VCT_ReceiveAudio \t( \tvoid *  \taudio_data,\n \t \t \tu32  \tlength,\n \t \t \tu16  \toutCIDList[] \n \t \t) \t\t\nExtracts audio data from the receive buffer.\nThe VCT_HandleData function decodes the received audio data. In Conference Mode, this function also acts internally to mix the audio if it is playing on more than one channel.\nThe audio data written to audio_data is in 16 bit/8 kHz format. This buffer must be aligned to a 32-byte boundary.\nThis function can be called regardless of whether audio streaming has started or not. If audio streaming has not started, the function clears the audio_data buffer to all zeroes.\nIf this function is called at varying intervals, breaks in the audio are more likely. If at all possible, call this function in precise multiples of the currently set audio frame length. (Use a timer or other means to call it in units of audio frames.) Use the VCT_GetAudioFrameLength function to get the currently set audio frame length.\nThis currently set audio frame length is the basis of the data size that is calculated for the length of audio data to write to the buffer. For length, specify the same value as this data size. If you specify any other value, data is not fetched. Use the VCT_GetAudioDataSize function to get the data size calculated based on the audio frame length that is currently set.\nSpecify outCIDList to get a list of the remote connection IDs that sent the stream. Use this option in Transceiver mode to do things such as switching the pan according to the person who is talking.\nYou can use the value returned by this function to determine whether there is any audio currently to play. This can be used to mute or turn down the volume of BGM when audio is playing.\nParameters\n\t \t[out]\taudio_data\tPointer to the audio data buffer.\n \t[in]\tlength\tSize of the audio data buffer.\n \t[out]\toutCIDList\tA list of connection IDs for clients that have sent this stream. It is possible to specify NULL.\nReturn values\n\t \ttrue\tAudio data was written to the buffer.\n \tfalse\tData is not audio data, streaming has not started, or the library is not initialized.\nRevision History:\n\t2012/04/03 - Revised the description of the outCIDList argument.\n2011/08/31 Initial version.\n \ts32 VCT_RemoveConferenceClient \t( \tu16  \tcid\t) \t\nRemoves a client from the conference.\nCall this function for all participants in the conference, and not just the person being removed.\nParameters\n\t \t[in]\tcid\tThe connection ID of the client to remove.\nReturn values\n\t \t0\tIndicates that the connection ID of the client was removed successfully.\n \tNegative\tThe error code that is returned when removal of the connection ID of the client fails.\nRevision History:\n\t2011/08/31 Initial version.\n \tvoid VCT_ResetVAD \t( \tvoid  \t\t) \t\nResets the internal VAD status.\nCall this function after making changes to the microphone gain or similar settings.\nRevision History:\n\t2011/08/31 Initial version.\n \tbool VCT_SendAudioEx \t( \tconst void *  \taudio_data,\n \t \t \tu32  \tmicScale,\n \t \t \tu32  \tmicOffset \n \t \t) \t\t\nQueues audio data in the send queue.\nThis function queues audio data in the send queue. This function also handles echo canceler processing.\nVAD processing, audio encoding, and the sending of data packets are all performed in the VCT_Main function.\nThe data in audio_data must have been sampled at 16 bits/8 kHz and aligned to a 32-byte boundary. Calling this function once queues data for a single audio frame using this pointer as the starting point To get the corresponding size of a single audio frame, use the VCT_GetAudioDataSize function.\nFor micScale, specify the volume scale value that was returned by the VCT_GetAudioScale function.\nFor micOffset, specify the number of samples that is the computed difference between the newest microphone sample at the time of function execution and the last sample of microphone data input to this function. Specify 0 to input the most recent microphone sample to this function.\nThis function can be called regardless of whether audio streaming has started. If audio streaming has not yet started, this function does nothing.\nIf this function is called at varying intervals, the timestamps on the send packets also vary, and the receiving system experiences more errors. If at all possible, call this function in precise multiples of the currently set audio frame length. (Use a timer or other means to call this function in units of audio frames.) Use the VCT_GetAudioFrameLength function to get the currently set audio frame length.\nNote: Use the VCT_GetVADActivity function to get the VAD determination result.\nParameters\n\t \t[in]\taudio_data\tThe audio data.\n \t[in]\tmicScale\tThe volume scale value for the audio data.\n \t[in]\tmicOffset\tSpecifies the offset (number of samples) between the latest microphone sample and last sample of the input microphone data.\nReturn values\n\t \ttrue\tThe audio data has been queued in the send queue.\n \tfalse\tThe audio data has not been queued in the send queue. (Streaming has not started, or the library is not initialized.)\nRevision History:\n\t2011/09/29 The session variable was declared const.\n2011/08/31 Initial version.\n \tbool VCT_SetAudioFrameLength \t( \tu32  \tframeLength\t) \t\nSets the audio frame length.\nFor frameLength, you must specify a value between VCT_AUDIO_FRAME_LENGTH_MIN and VCT_AUDIO_FRAME_LENGTH_MAX that is also an integer multiple of 8.\nParameters\n\t \t[in]\tframeLength\tAudio frame length (in milliseconds).\nReturn values\n\t \ttrue\tConfiguration succeeded.\n \tfalse\tConfiguration failed.\nRevision History:\n\t2011/08/31 Initial version.\n \tbool VCT_SetCodec \t( \tVCTCodec  \tcodec\t) \t\nSets the audio codec.\nThe codec can be changed even while streaming.\nThe only supported codecs are 4-bit ADPCM and 2-bit ADPCM. Returns false when an unsupported audio codec is specified.\nUse the VCT_SetSpareCodec function to change the audio codec for spare packets.\nParameters\n\t \t[in]\tcodec\tThe changed audio codec type for the sender.\nReturn values\n\t \ttrue\tAudio data was written to the buffer.\n \tfalse\tData is not audio data, streaming has not started, or the library is not initialized.\nRevision History:\n\t2011/08/31 Initial version.\n \tvoid VCT_SetNoiseSkipTime \t( \tu32  \tcount\t) \t\nSets the length of time for which sound is not sent in VCT_SignalNoiseSkip.\nParameters\n\t \t[in]\tcount\tSpecifies the length of time sound is not sent (in milliseconds).\nRevision History:\n\t2012/03/01 Initial version.\n \tbool VCT_SetSpareCodec \t( \tVCTCodec  \tspareCodec\t) \t\nSets the audio codec for spare packets.\nBy default, spare packets use the 2-bit ADPCM codec.\nUse the VCT_SetCodec function to change the codec for main packets.\nNote: The only codec type supported for spare packets is 2-bit ADPCM. Accordingly, this function does not need to be called at this time. Returns false when an unsupported codec has been specified.\nParameters\n\t \t[in]\tspareCodec\tThe spare packet codec type.\nReturn values\n\t \ttrue\tSetting succeeded.\n \tfalse\tSetting failed.\nRevision History:\n\t2011/08/31 Initial version.\n \tvoid VCT_SetVADActiveGain \t( \tu16  \tvalue\t) \t\nSets the speech frame detection threshold.\nWhen the previous audio frame is recognized as a silent frame, this threshold value is used to determine whether the current audio frame contains speech.\nA frame is recognized as containing speech when the following condition is met, where Ts is the threshold value, Ec is the average speech power of the audio data in the current frame, and En is the average speech power of the audio data in the four previous frames.\nEc > En * Ts / 100\nThe value argument takes the threshold (Ts). The default value is 350. In this case, the threshold of the power difference between En and Ec is equivalent to 20 * log (350 / 100) = 10.9 dB.\nParameters\n\t \t[in]\tvalue\tSpecifies the speech frame detection threshold.\nRevision History:\n\t2011/08/31 Initial version.\n \tvoid VCT_SetVADClampGain \t( \tu32  \tvalue\t) \t\nSets the volume threshold as a volume scale value (the square of the average power) for unconditionally determining silence.\nvalue takes a volume scale value in a range from 0 through 0x3FFFFFFF. Any audio frame with a volume scale value below this specified threshold is determined to be a silent frame.\nUses the volume scale value for audio data obtained by the VCT_GetAudioScale function.\nThe default value is 49.\nParameters\n\t \t[in]\tvalue\tThe volume threshold at which a frame is unconditionally determined to be silent.\nRevision History:\n\t2011/08/31 Initial version.\n \tvoid VCT_SetVADInactiveGain \t( \tu16  \tvalue\t) \t\nSets the silent frame detection threshold.\nWhen the previous audio frame is recognized as a speech frame, this threshold value is used to determine whether the current audio frame is silent.\nA frame is recognized as being a silent frame when the following condition is met, where Tn is the threshold value, Ec is the average speech power of the audio data in the most-recent four frames, and En is the average speech power of the audio data in the four frames prior to the last audio frame that was determined to be a silent frame.\nEc < En * Tn / 100\nHowever, the sending of audio frames actually stops when silence is determined to continue for the consecutive number of frames specified by the VCT_SetVADReleaseTime function.\nThe value argument takes the threshold (Tn). The default value is 280. In this case, the threshold of the power difference between En and Ec is equivalent to 20 * log (280 / 100) = 8.94 dB.\nParameters\n\t \t[in]\tvalue\tSpecifies the silent frame detection threshold.\nRevision History:\n\t2011/08/31 Initial version.\n \tvoid VCT_SetVADReleaseTime \t( \tu32  \tcount\t) \t\nSets the time that must elapse after silence is detected before packet transmission is stopped.\nTo prevent VAD from detecting silence in the middle of a conversation because, for example, the user takes a breath, set the release time to at least 500 ms.\nFor count, specify the time (in packets) to wait after VAD has detected silence before packet transmission is halted. The default is 5 packets (144 * 5 = 720 ms).\nParameters\n\t \t[in]\tcount\tRelease time (in number of packets).\nRevision History:\n\t2011/08/31 Initial version.\n \tvoid VCT_SignalNoiseSkip \t( \tvoid  \t\t) \t\nWhen VAD is enabled and not active, this function makes VAD active on the sound of button presses so that audio is not sent.\nSetting up this function enables you to prevent the VAD feature from activating and sending audio on the sound of button presses when VAD is enabled but not active. By not sending audio for a certain time period after button presses, you can minimize the button pressing sounds received by other players.\nThis function cannot remove button-press sounds while VAD is active and a conversation is being sent.\nThe duration (in milliseconds) to not send sound is specified with VCT_SetNoiseSkipTime.\nRevision History:\n\t2012/05/10 - Revised the description.\n2012/03/15 - Supplemented the description.\n2012/03/01 Initial version.\n \tbool VCT_StartStreaming \t( \tconst VCTSession *  \tsession\t) \t\nStarts audio streaming.\nCall this function after the session has been established.\nParameters\n\t \t[in]\tsession\tThe session for which to start streaming.\nReturn values\n\t \ttrue\tSuccess.\n \tfalse\tFailed.\nRevision History:\n\t2011/09/29 - Clarified that the session variable is const.\n2011/08/31 Initial version.\n \tvoid VCT_StopStreaming \t( \tconst VCTSession *  \tsession\t) \t\nStops audio streaming.\nParameters\n\t \t[in]\tsession\tThe session for which to stop streaming.\nRevision History:\n\t2011/09/29 The session variable was declared const.\n2011/08/31 Initial version.\n",1]
,["external.html?file=../../../API/html/vct_8h_source.html","CTR-VCT: include/mw/vct/vct.h Source File",
"Go to the documentation of this file. 1 /*---------------------------------------------------------------------------*\n 2 Project: VoiceChat library\n 3 File: vct.h\n 4 \n 5 Copyright (C) 2011-2014 Nintendo Co., Ltd. All rights reserved.\n 6 \n 7 These coded instructions, statements, and computer programs contain\n 8 proprietary information of Nintendo of America Inc. and/or Nintendo\n 9 Company Ltd., and are protected by Federal copyright law. They may\n 10 not be disclosed to third parties or copied or duplicated in any form,\n 11 in whole or in part, without the prior written consent of Nintendo.\n 12  *---------------------------------------------------------------------------*/\n 13 \n 14 \n 15 #ifndef VCT_VOICECHAT_H_\n 16 #define VCT_VOICECHAT_H_\n 17 \n 18 /*---------------------------------------------------------------------------*\n 19 Include\n 20  *---------------------------------------------------------------------------*/\n 21 #ifdef NN_VCT_TARGET_CAFE\n 22 \n 23 #include <cafe.h>\n 24 \n 25 #elif NN_VCT_TARGET_CTR\n 26 \n 27 #include <nn.h>\n 28 \n 29 #endif\n 30 \n 31 \n 32 /*---------------------------------------------------------------------------*\n 33 Extern \"C\"\n 34  *---------------------------------------------------------------------------*/\n 35 #ifdef __cplusplus\n 36 extern \"C\" {\n 37 #endif // ifdef __cplusplus\n 38 \n 39 \n 40 /*---------------------------------------------------------------------------*\n 41 Define\n 42  *---------------------------------------------------------------------------*/\n 43 // --- Common error codes.\n 44 #define VCT_ERROR_NONE 0\n 45 #define VCT_ERROR_BAD_PARAM -1\n 46 #define VCT_ERROR_BAD_MODE -2\n 47 #define VCT_ERROR_BAD_REQUEST -3\n 48 #define VCT_ERROR_SEND_FAIL -4\n 49 #define VCT_ERROR_EXHAUST_CLIENTS -6\n 50 \n 51 // --- Session and client limitations.\n 52 #define VCT_MAX_SESSION 16\n 53 #define VCT_MAX_CONFERENCE_CLIENT 16\n 54 #define VCT_MAX_CLIENT 16\n 55 \n 56 #define VCT_MAX_AUDIO_STREAM (VCT_MAX_CONFERENCE_CLIENT - 1)\n 57 \n 58 // Magic Number in VCT\n 59 #define VCT_MAGIC_PACKET_HEADER 0x5f564354 //!< Magic number in the VCT packet header.\n 60 \n 61 #define VCT_CODEC_DEFAULT VCT_CODEC_4BIT_ADPCM //!< Default audio codec.\n 62 #define VCT_SPARE_CODEC_DEFAULT VCT_CODEC_2BIT_ADPCM //!< Default audio codec for spare packets.\n 63 \n 64 #define VCT_AUDIO_FRAME_LENGTH_MIN 64 //!< Specifies the minimum audio frame length (in milliseconds).\n 65 #define VCT_AUDIO_FRAME_LENGTH_MAX 192 //!< Specifies the maximum audio frame length (in milliseconds).\n 66 #define VCT_AUDIO_FRAME_LENGTH_DEFAULT 144 //!< Specifies the default audio frame length (in milliseconds).\n 67 \n 68 #define VCT_AUDIO_DATA_SIZE_PER_MILLI_SEC 16\n 69 \n 70 #define VCT_AUDIO_DATA_SIZE_MIN (VCT_AUDIO_FRAME_LENGTH_MIN * VCT_AUDIO_DATA_SIZE_PER_MILLI_SEC)\n 71 #define VCT_AUDIO_DATA_SIZE_MAX (VCT_AUDIO_FRAME_LENGTH_MAX * VCT_AUDIO_DATA_SIZE_PER_MILLI_SEC)\n 72 #define VCT_AUDIO_DATA_SIZE_DEFAULT (VCT_AUDIO_FRAME_LENGTH_DEFAULT * VCT_AUDIO_DATA_SIZE_PER_MILLI_SEC)\n 73 \n 74 #define VCT_AUDIO_FRAME_RATE 8000 //!< Audio frame rate (8 kHz).\n 75 \n 76 // --- Receive buffer size.\n 77 #define VCT_AUDIO_HEADER_SIZE 12 //!< Header size for VCT audio data packets.\n 78 #define VCT_AUDIO_2_BIT_ADPCM_PACKET_SIZE_MAX (VCT_AUDIO_HEADER_SIZE + 2 * VCT_AUDIO_FRAME_LENGTH_MAX + 4)\n 79 #define VCT_AUDIO_3_BIT_ADPCM_PACKET_SIZE_MAX (VCT_AUDIO_HEADER_SIZE + 3 * VCT_AUDIO_FRAME_LENGTH_MAX + 4)\n 80 #define VCT_AUDIO_4_BIT_ADPCM_PACKET_SIZE_MAX (VCT_AUDIO_HEADER_SIZE + 4 * VCT_AUDIO_FRAME_LENGTH_MAX + 4)\n 81 \n 82 #define VCT_AUDIO_SPARE_PACKET_SIZE_MAX VCT_AUDIO_2_BIT_ADPCM_PACKET_SIZE_MAX\n 83 \n 84 #define VCT_AUDIO_PACKET_BUFFER_SIZE (VCT_AUDIO_DATA_SIZE_MAX + VCT_AUDIO_SPARE_PACKET_SIZE_MAX)\n 85 \n 86 #ifdef NN_VCT_TARGET_CAFE\n 87 #define VCT_AUDIO_BUFFER_PACKET_HEADER 64\n 88 #elif NN_VCT_TARGET_CTR\n 89 #define VCT_AUDIO_BUFFER_PACKET_HEADER 56\n 90 #endif\n 91 #define VCT_AUDIO_BUFFER_SIZE (VCT_AUDIO_PACKET_BUFFER_SIZE + VCT_AUDIO_BUFFER_PACKET_HEADER)\n 92 \n 93 #define VCT_DEFAULT_AUDIO_BUFFER_COUNT 8\n 94 #define VCT_MIN_AUDIO_BUFFER_COUNT 4\n 95 #define VCT_MAX_AUDIO_BUFFER_COUNT (24 * VCT_MAX_AUDIO_STREAM)\n 96 \n 97 #define VCT_DEFAULT_AUDIO_BUFFER_SIZE (VCT_AUDIO_BUFFER_SIZE \\\n 98  * VCT_DEFAULT_AUDIO_BUFFER_COUNT \\\n 99  * VCT_MAX_AUDIO_STREAM)\n 100 \n 101 #ifdef NN_VCT_TARGET_CAFE\n 102  #define VCT_VAD_DETECT_GAIN_UP_DEFAULT 350\n 103  #define VCT_VAD_LOST_GAIN_UP_DEFAULT 280\n 104 #elif NN_VCT_TARGET_CTR\n 105  #define VCT_VAD_DETECT_GAIN_UP_DEFAULT 350\n 106  #define VCT_VAD_LOST_GAIN_UP_DEFAULT 280\n 107 #endif\n 108 \n 109 #define VCT_VAD_INVALID_SCALE_THRESHOLD_DEFAULT (7 * 7)\n 110 #define VCT_VAD_CLAMP_GAIN_MAX 0x3FFFFFFF\n 111 #define VCT_VAD_RELEASE_TIME_DEFAULT 5 // 144 (default frame length) * 5 = 720 ms\n 112 \n 113 // --- Library configuration.\n 114 #define VCT_CONFIG_FLAG_NONE 0x00\n 115 #define VCT_CONFIG_FLAG_VAD 0x01 //!< VAD (Voice Activity Detection) feature.\n 116 #define VCT_CONFIG_FLAG_ECHO_CANCEL 0x02 //!< Echo cancellation.\n 117 #define VCT_CONFIG_FLAG_HPF 0x04 //!< High-pass filter.\n 118 #define VCT_CONFIG_FLAG_SPARE_PACKET 0x08 //!< Spare packet.\n 119 #define VCT_CONFIG_FLAG_DROP_RECOVER 0x20 //!< Drop recovery.\n 120 #define VCT_CONFIG_FLAG_BPF 0x40 //!< Biquad filter.\n 121 #define VCT_CONFIG_FLAG_ALL 0xff\n 122 \n 123 #ifdef NN_VCT_TARGET_CAFE\n 124  #define VCT_CONFIG_FLAG_DEFAULT (VCT_CONFIG_FLAG_VAD | \\\n 125  VCT_CONFIG_FLAG_SPARE_PACKET | \\\n 126  VCT_CONFIG_FLAG_DROP_RECOVER)\n 127 #elif NN_VCT_TARGET_CTR\n 128  #define VCT_CONFIG_FLAG_DEFAULT (VCT_CONFIG_FLAG_VAD | \\\n 129  VCT_CONFIG_FLAG_ECHO_CANCEL | \\\n 130  VCT_CONFIG_FLAG_SPARE_PACKET | \\\n 131  VCT_CONFIG_FLAG_DROP_RECOVER)\n 132 #endif\n 133 \n 134 \n 135 // --- VoiceChat mode.\n 136 /* @enum VCTMode\n 137 * @brief Enumerates chat modes. */\n 138 typedef enum {\n 139  VCT_MODE_NULL,\n 140  VCT_MODE_CONFERENCE //!< Conference mode.\n 141 } VCTMode;\n 142 \n 143 /*!\n 144 @brief Enumerates session states.\n 145  */\n 146 typedef enum {\n 147  VCT_STATE_INIT, //!< Specifies an initialized state.\n 148  VCT_STATE_TALKING //!< Specifies that the peers are talking.\n 149 } VCTState;\n 150 \n 151 /*!\n 152 @brief Enumerates voice chat library events.\n 153  */\n 154 typedef enum {\n 155  VCT_EVENT_NONE,\n 156  VCT_EVENT_CONNECTED, //!< Connected to the remote client.\n 157  VCT_EVENT_DISCONNECTED //!< Disconnected.\n 158 } VCTEvent;\n 159 \n 160 /*!\n 161 @brief Enumerates audio codecs.\n 162  */\n 163 typedef enum {\n 164  VCT_CODEC_8BIT_RAW, //!< Specifies 8-bit 8 kHz raw audio.\n 165  VCT_CODEC_G711_ULAW, //!< Specifies G711 u-Law.\n 166  VCT_CODEC_2BIT_ADPCM, //!< Specifies 2-bit IMA-ADPCM (non-standard).\n 167  VCT_CODEC_3BIT_ADPCM, //!< Specifies 3-bit IMA-ADPCM.\n 168  VCT_CODEC_4BIT_ADPCM, //!< Specifies 4-bit IMA-ADPCM.\n 169 \n 170  VCT_CODEC_END\n 171 } VCTCodec;\n 172 \n 173 /*!\n 174 @brief Enumerates echo cancellation modes.\n 175  */\n 176 typedef enum {\n 177  VCT_EC_STANDARD, //!< Specifies standard echo cancellation.\n 178  VCT_EC_HIGHPERFORMANCE //!< Specifies high-performance echo cancellation (only available in debug mode).\n 179 } VCTECMode;\n 180 \n 181 typedef struct VCTSession_ VCTSession;\n 182 \n 183 // --- Callback function prototypes.\n 184 \n 185 /*!\n 186 @brief Defines the type for an event callback.\n 187 \n 188 @see VCTConfig, VCTSendCallback\n 189  */\n 190 typedef void (*VCTEventCallback)( u16 cid, VCTEvent result, VCTSession *session, void *param );\n 191 \n 192 /*!\n 193 @brief Defines the type for a send callback.\n 194 \n 195 @see VCTConfig, VCTEventCallback\n 196  */\n 197 typedef bool (*VCTSendCallback) ( u16 cid, const void *buff, u32 size, bool isReliable );\n 198 \n 199 /*!\n 200 @brief Stores information related to audio.\n 201 */\n 202 typedef struct\n 203 {\n 204  VCTCodec codec; //!< Specifies the audio codec of the peer.\n 205  u8 padding0_[3]; //!< Represents a reserved region.\n 206 \n 207  u32 sequence; //!< Sequence number of the current audio packet.\n 208 \n 209 #ifdef NN_VCT_TARGET_CAFE\n 210  OSTime bufferLatency; //!< Latency of the jitter buffer.\n 211  OSTime jitter; //!< Maximum jitter (in ticks).\n 212  OSTime clockSkew; //!< Clock skew (in ticks).\n 213 #elif NN_VCT_TARGET_CTR\n 214  nn::os::Tick bufferLatency; //!< Latency of the jitter buffer.\n 215  nn::os::Tick jitter; //!< Maximum jitter (in ticks).\n 216  nn::os::Tick clockSkew; //!< Clock skew (in ticks).\n 217 #endif\n 218 \n 219  u32 internalLatency; //!< Internal library latency.\n 220  u32 bufferCount; //!< Specifies the number of packets in the jitter buffer.\n 221  u32 dropCount; //!< Specifies the number of packets that were dropped.\n 222  u32 continuousDrop; //!< Number of consecutive dropped packets in the most recent frame.\n 223 \n 224  u32 jamCount; //!< Number of jammed packets.\n 225  u32 duplicateCount; //!< Specifies the number of duplicate packets.\n 226  u32 waitCount; //!< Number of packets on hold due to the loss of the previous packet.\n 227  u32 lateCount; //!< Number of packets that were late due to network traffic or another reason.\n 228 \n 229  u32 recentLateCount; //!< Number of packets that arrived late in the most recent frame.\n 230  u32 recentReceiveCount; //!< Number of packets that arrived in the most recent frame.\n 231  u32 recentLateRatio; //!< Ratio of packets that were late (<tt>recentLateCount</tt> / <tt>recentReceiveCount</tt>).\n 232  u32 recoverCount; //!< Number of recovered packets.\n 233 \n 234  u32 recoverUsingSpareCount; //!< Number of packets that were recovered using spare packets.\n 235  u32 padding1_; //!< Represents a reserved region.\n 236 } VCTAudioInfo;\n 237 \n 238 // --- SSP session information.\n 239 /*!\n 240 @brief Defines the structure for a session. Used for managing CIDs and the session state.\n 241 \n 242 @see VCTConfig\n 243 */\n 244 typedef struct VCTSession_\n 245 {\n 246  VCTMode mode; //!< Chat mode in this session.\n 247  u8 _padding0_; //!< Represents a reserved region.\n 248  u16 cid; //!< Remote CID.\n 249  u16 _padding1_; //!< Represents a reserved region.\n 250  u16 cidList[VCT_MAX_CLIENT]; //!< List of client CIDs in conference mode.\n 251  VCTState state; //!< State of this session.\n 252  u8 _padding2_; //!< Represents a reserved region.\n 253  void* userData; //!< User data.\n 254 \n 255  VCTSession* _next;\n 256 } VCTSession;\n 257 \n 258 /*!\n 259 @cond PRIVATE\n 260 @brief Stores data related to the biquad filter.\n 261 */\n 262 typedef struct vct_biquad_data\n 263 {\n 264  s16 input1;\n 265  s16 input2;\n 266  s16 output1;\n 267  s16 output2;\n 268 } vct_biquad_data;\n 269 //! @endcond\n 270 \n 271 \n 272 /*!\n 273 @cond PRIVATE\n 274 @brief Stores information related to the VAD (Voice Activity Detection) feature.\n 275 */\n 276 typedef struct VCTVADInfo\n 277 {\n 278  u32 scale; //!< Scale for input audio (0-127).\n 279  u32 releaseCount; //!< VAD release count.\n 280  u32 releaseTime; //!< VAD release time.\n 281  bool activity; //!< <tt>true</tt> if VAD detects sound, or <tt>false</tt> if VAD detects noise.\n 282  u8 _padding_[3]; //!< Reserved.\n 283 } VCTVADInfo;\n 284 //! @endcond\n 285 \n 286 /*!\n 287 @brief Stores initialization parameters for the VCT library.\n 288 \n 289 @see VCT_Init\n 290 \n 291 @date 2011/10/21 Added the <tt>ecMode</tt> member to specify the operation mode of echo cancellation.\n 292 */\n 293 typedef struct\n 294 {\n 295  VCTSession* session; //!< Specifies the region to save the <tt>VCTSession</tt> structure in.\n 296  u32 numSession; //!< Specifies the size of the region specified in <tt>session</tt>.\n 297  VCTMode mode; //!< Specifies the chat mode (always specify <tt>VCT_MODE_CONFERENCE</tt>).\n 298  VCTECMode ecMode; //!< Specifies the operation mode of echo cancellation.\n 299  u16 cid; //!< Specifies the CID of the client.\n 300  u8 codec; //!< Specifies the codec for the main packets (always specify <tt>VCT_CODEC_4BIT_ADPCM</tt>).\n 301  u8 frameLength; //!< Specifies the audio frame length in milliseconds.\n 302  u8 flag; //!< Enables or disables VAD, spare packets, drop recovery, and high-pass filter features.\n 303  u8 _padding1_; //!< Represents a reserved region.\n 304  void* audioBuffer; //!< Specifies the receive buffer for the audio stream (requires 32-byte alignment).\n 305  u32 audioBufferSize; //!< Specifies the size of the buffer specified in <tt>audioBuffer</tt>.\n 306  VCTEventCallback callback; //!< Specifies the event callback function.\n 307  VCTSendCallback sendCallback; //!< Specifies the send callback function.\n 308  void* userData; //!< Specifies the user data to pass when calling the callback function.\n 309 \n 310 } VCTConfig;\n 311 \n 312 \n 313 /*===========================================================================*\n 314  *\n 315 * Initialize / Finalize Functions\n 316  *\n 317  *===========================================================================*/\n 318 /*!\n 319 @name Initialization and Finalization\n 320  @{\n 321 */\n 322  /*!\n 323 @brief This function initializes the VCT library.\n 324 \n 325 @param[in] config <tt>@ref VCTConfig</tt> structure.\n 326 \n 327 @retval true Initialization succeeded.\n 328 @retval false Initialization failed.\n 329 \n 330 @date 2011/08/31 Initial version.\n 331  */\n 332 bool VCT_Init ( VCTConfig* config );\n 333 \n 334  /*!\n 335 @brief Checks whether the VCT library is finished being initialized.\n 336 \n 337 @retval true Already initialized.\n 338 @retval false Pre-initialized state.\n 339 \n 340 @date 2011/08/31 Initial version.\n 341  */\n 342 bool VCT_IsInitialized ( void );\n 343 \n 344  /*!\n 345 @brief Finalizes the VCT library.\n 346 \n 347 @details Call this function when finalizing VoiceChat or changing the operation mode (<tt>@ref VCTMode</tt>).\n 348 \n 349 @date 2011/08/31 Initial version.\n 350  */\n 351 \n 352 void VCT_Cleanup ( void );\n 353 \n 354  /*!\n 355 @brief This function runs the main loop of the VCT library.\n 356 \n 357 @details Sends the audio data queued by <tt>@ref VCT_SendAudioEx</tt> and decodes the received audio data passed by <tt>@ref VCT_HandleData</tt>.\n 358 \n 359 @details The process for sending data that takes place inside <tt>VCT_Main</tt> (the calling of the send callback) must be called a sufficient number of times, so you also need to call <tt>VCT_Main</tt> a sufficient number of times.\n 360 If the audio frame length is <i>length</i> ms and there are <i>num</i> number of communication partners, you must call it more than (<i>num</i> * 1000 / <i>length</i>) times each second.\n 361 For example, if the audio frame length is 144 ms and there are 8 connected systems, the calculation is 7 * 1000 / 144 = 48.6, so you must call it about 50 to 60 times each second.\n 362 Also, make calls at regular intervals rather than all at once whenever possible, because audio processing is performed at regular intervals. For example, call it a sufficient number of times in each game frame.\n 363 \n 364 @date 2013/06/07 Added a description of the number of times to call <tt>VCT_Main</tt>.\n 365 @date 2011/08/31 Initial version.\n 366 \n 367 */\n 368 void VCT_Main ( void );\n 369 \n 370 /*!\n 371 end of name Initialization and Finalization\n 372  @}\n 373 */\n 374 \n 375 /*!\n 376 @name Per-frame Execution\n 377  @{\n 378 */\n 379 \n 380  /*!\n 381 @brief Processes voice chat data.\n 382 \n 383 @details Pass the data received by the communications library to this function.\n 384 \n 385 @note If the return value is <tt>true</tt> (that is, the received data is voice chat data), no additional processing is necessary because the callback function specified in the <tt>callback</tt> member variable of the <tt>@ref VCTConfig</tt> structure is called from this function.\n 386 If the return value is <tt>false</tt>, the received data is something other than voice chat data (game data, for example), and you must implement some means for the application to perform the necessary processing on the data.\n 387 \n 388 @param[in] cid <tt>ConnectionID</tt> of the data sender.\n 389 @param[in] buffer Pointer to the start of the received data.\n 390 @param[in] size The size of the received data. This value is in bytes.\n 391 \n 392 @retval true The passed data is voice chat data.\n 393 @retval false Either the passed data is voice chat data, or the VCT library is not initialized.\n 394 \n 395 @date 2013/06/07 Revised the description.\n 396 @date 2011/08/31 Initial version.\n 397 \n 398 \n 399 \n 400 */\n 401 bool VCT_HandleData ( u16 cid, u8* buffer, u32 size );\n 402 \n 403 /*!\n 404 end of name Per-frame Execution\n 405  @}\n 406 */\n 407 \n 408  /*!\n 409 @brief Deletes the specified session.\n 410 \n 411 @param[in] session The <tt>@ref VCTSession</tt> structure to delete.\n 412 @retval true Deletion succeeded.\n 413 @retval false Deletion failed.\n 414 \n 415 @date 2011/08/31 Initial version.\n 416  */\n 417 bool VCT_DeleteSession ( VCTSession *session );\n 418 \n 419  /*!\n 420 @brief Adds a client to the conference.\n 421 \n 422 @details One's own connection ID does not need to be specified. (It is ignored internally by the function even if it is specified.) To start a conference, this function must be called by all parties for each other. For example, for three systems with the connection IDs 1, 2, and 3 to start a conference, system 1 must add 2 and 3, system 2 must add 1 and 3, and system 3 must add 1 and 2.\n 423 \n 424 @details If N is the maximum number of people who can connect in a conference, the maximum number of clients that the local system can add to a conference is N - 1. Before adding clients you must use the <tt>@ref VCT_Init</tt> function to specify x number of <tt>@ref VCTSession</tt> structures, where x = (total number of participants - 1). If there are not enough sessions, the function returns an error.\n 425 \n 426 @details An error also occurs if this function is called and the mode is not <tt>VCT_MODE_CONFERENCE</tt>.\n 427 \n 428 @param[in] cid The connection ID of the client being added.\n 429 \n 430 \n 431 @retval 0 Indicates that the connection ID of the client was added successfully.\n 432 @retval Negative The error code when adding the connection ID of the client failed.\n 433 \n 434 @date 2013/06/11 Fixed a mistake in the description of the return value.\n 435 @date 2011/08/31 Initial version.\n 436  */\n 437 s32 VCT_AddConferenceClient ( u16 cid );\n 438 \n 439  /*!\n 440 @brief Removes a client from the conference.\n 441 \n 442 @details Call this function for all participants in the conference, and not just the person being removed.\n 443 \n 444 @param[in] cid The connection ID of the client to remove.\n 445 \n 446 \n 447 @retval 0 Indicates that the connection ID of the client was removed successfully.\n 448 @retval Negative The error code that is returned when removal of the connection ID of the client fails.\n 449 @date 2011/08/31 Initial version.\n 450  */\n 451 \n 452 s32 VCT_RemoveConferenceClient ( u16 cid );\n 453  /*!\n 454 @brief Returns whether a client is in the conference.\n 455 \n 456 @param[in] cid The connection ID of the client to check for membership in the conference.\n 457 \n 458 @retval true Participating.\n 459 @retval false Not a member.\n 460 \n 461 @date 2011/08/31 Initial version.\n 462  */\n 463 bool VCT_OnConferenceClient ( u16 cid );\n 464 \n 465 /*===========================================================================*\n 466  *\n 467 * Audio Streaming Functions\n 468  *\n 469  *===========================================================================*/\n 470 /*!\n 471 @name Audio Streaming\n 472  @{\n 473 */\n 474  /*!\n 475 @brief Starts audio streaming.\n 476 \n 477 @details Call this function after the session has been established.\n 478 \n 479 @param[in] session The session for which to start streaming.\n 480 \n 481 @retval true Success.\n 482 @retval false Failed.\n 483 \n 484 @date 2011/09/29 - Clarified that the <tt>session</tt> variable is <tt>const</tt>.\n 485 @date 2011/08/31 Initial version.\n 486  */\n 487 \n 488 \n 489 bool VCT_StartStreaming ( const VCTSession *session );\n 490 \n 491 \n 492  /*!\n 493 @brief Clears audio streaming.\n 494 \n 495 @param[in] session The session for which to clear streaming.\n 496 \n 497 @date 2013/02/15 Initial version.\n 498  */\n 499 \n 500 void VCT_ClearStreaming( const VCTSession *session );\n 501  /*!\n 502 @brief Stops audio streaming.\n 503 \n 504 @param[in] session The session for which to stop streaming.\n 505 \n 506 @date 2011/09/29 The <tt>session</tt> variable was declared <tt>const</tt>.\n 507 @date 2011/08/31 Initial version.\n 508  */\n 509 void VCT_StopStreaming ( const VCTSession *session );\n 510 \n 511 #ifdef NN_VCT_TARGET_CTR\n 512  /*!\n 513 @brief Queues audio data in the send queue.\n 514 \n 515 @details This function queues audio data in the send queue. This function also handles echo canceler processing.\n 516 \n 517 @details VAD processing, audio encoding, and the sending of data packets are all performed in the <tt>@ref VCT_Main</tt> function.\n 518 \n 519 @details The data in <span class=\"argument\">audio_data</span> must have been sampled at 16 bits/8 kHz and aligned to a 32-byte boundary. Calling this function once queues data for a single audio frame using this pointer as the starting point To get the corresponding size of a single audio frame, use the <tt>@ref VCT_GetAudioDataSize</tt> function.\n 520 \n 521 @details For <span class=\"argument\">micScale</span>, specify the volume scale value that was returned by the <tt>@ref VCT_GetAudioScale</tt> function.\n 522 \n 523 @details For <span class=\"argument\">micOffset</span>, specify the number of samples that is the computed difference between the newest microphone sample at the time of function execution and the last sample of microphone data input to this function. Specify <tt>0</tt> to input the most recent microphone sample to this function.\n 524 \n 525 @details This function can be called regardless of whether audio streaming has started. If audio streaming has not yet started, this function does nothing.\n 526 \n 527 @details If this function is called at varying intervals, the timestamps on the send packets also vary, and the receiving system experiences more errors. If at all possible, call this function in precise multiples of the currently set audio frame length. (Use a timer or other means to call this function in units of audio frames.) Use the <tt>@ref VCT_GetAudioFrameLength</tt> function to get the currently set audio frame length.\n 528 \n 529 @details <b>Note:</b> Use the <tt>@ref VCT_GetVADActivity</tt> function to get the VAD determination result.\n 530 \n 531 \n 532 @param[in] audio_data The audio data.\n 533 @param[in] micScale The volume scale value for the audio data.\n 534 \n 535 @param[in] micOffset Specifies the offset (number of samples) between the latest microphone sample and last sample of the input microphone data.\n 536 \n 537 @retval true The audio data has been queued in the send queue.\n 538 @retval false The audio data has not been queued in the send queue. (Streaming has not started, or the library is not initialized.)\n 539 \n 540 @date 2011/09/29 The <tt>session</tt> variable was declared <tt>const</tt>.\n 541 @date 2011/08/31 Initial version.\n 542  */\n 543 #elif NN_VCT_TARGET_CAFE\n 544  /*!\n 545 @brief Queues audio data in the send queue.\n 546 \n 547 @details This function queues audio data in the send queue. It also performs echo cancellation.\n 548 \n 549 @details VAD processing, audio encoding, and the sending of data packets are all performed in the <tt>@ref VCT_Main</tt> function.\n 550 \n 551 @details The data in <span class=\"argument\">audio_data</span> must have been sampled at 16 bits/8 kHz and aligned to a 32-byte boundary. Calling this function once queues data for a single audio frame using this pointer as the starting point. To get the corresponding size of a single audio frame, use the <tt>@ref VCT_GetAudioDataSize</tt> function.\n 552 \n 553 @details For <span class=\"argument\">micScale</span>, specify the volume scale value that was returned by the <tt>@ref VCT_GetAudioScale</tt> function.\n 554 \n 555 @details For <span class=\"argument\">micOffset</span>, specify the number of samples that is the computed difference between the newest microphone sample at the time of function execution and the last sample of microphone data input to this function. Specify <tt>0</tt> to input the most recent microphone sample to this function.\n 556 \n 557 @details This function can be called regardless of whether audio streaming has started. If audio streaming has not started, this function does nothing.\n 558 \n 559 @details If this function is called at varying intervals, the timestamps on the send packets also vary, and the receiving system experiences more errors. If at all possible, call this function in precise multiples of the currently set audio frame length. (Use a timer or other means to call this function in units of audio frames.) Use the <tt>@ref VCT_GetAudioFrameLength</tt> function to get the currently set audio frame length.\n 560 \n 561 @details <b>Note:</b> Use the <tt>@ref VCT_GetVADActivity</tt> function to get the VAD determination result.\n 562 \n 563 \n 564 @param[in] audio_data The audio data.\n 565 @param[in] micScale The volume scale value for the audio data.\n 566 \n 567 @retval true The audio data has been queued in the send queue.\n 568 @retval false The audio data has not been queued in the send queue. (Streaming has not started, or the library is not initialized.)\n 569 \n 570 @date 2011/09/29 The <tt>session</tt> variable was declared <tt>const</tt>.\n 571 @date 2011/08/31 Initial version.\n 572  */\n 573 \n 574 #endif\n 575 \n 576 #ifdef NN_VCT_TARGET_CTR\n 577 bool VCT_SendAudioEx ( const void *audio_data, u32 micScale, u32 micOffset );\n 578 #endif\n 579 #ifdef NN_VCT_TARGET_CAFE\n 580 bool VCT_SendAudioEx ( const void *audio_data, u32 micScale);\n 581 #endif\n 582  /*!\n 583 @brief Extracts audio data from the receive buffer.\n 584 \n 585 @details The <tt>@ref VCT_HandleData</tt> function decodes the received audio data.\n 586 In Conference Mode, this function also acts internally to mix the audio if it is playing on more than one channel.\n 587 \n 588 @details The audio data written to <span class=\"argument\">audio_data</span> is in 16 bit/8 kHz format. This buffer must be aligned to a 32-byte boundary.\n 589 \n 590 @details This function can be called regardless of whether audio streaming has started or not.\n 591 If audio streaming has not started, the function clears the <span class=\"argument\">audio_data</span> buffer to all zeroes.\n 592 \n 593 @details If this function is called at varying intervals, breaks in the audio are more likely. If at all possible, call this function in precise multiples of the currently set audio frame length. (Use a timer or other means to call it in units of audio frames.)\n 594 Use the <tt>@ref VCT_GetAudioFrameLength</tt> function to get the currently set audio frame length.\n 595 \n 596 @details This currently set audio frame length is the basis of the data size that is calculated for the length of audio data to write to the buffer.\n 597 For <span class=\"argument\">length</span>, specify the same value as this data size. If you specify any other value, data is not fetched.\n 598 Use the <tt>@ref VCT_GetAudioDataSize</tt> function to get the data size calculated based on the audio frame length that is currently set.\n 599 \n 600 @details Specify <span class=\"argument\">outCIDList</span> to get a list of the remote connection IDs that sent the stream.\n 601 Use this option in Transceiver mode to do things such as switching the pan according to the person who is talking.\n 602 \n 603 @details You can use the value returned by this function to determine whether there is any audio currently to play.\n 604 This can be used to mute or turn down the volume of BGM when audio is playing.\n 605 \n 606 @param[out] audio_data Pointer to the audio data buffer.\n 607 @param[in] length Size of the audio data buffer.\n 608 @param[out] outCIDList A list of connection IDs for clients that have sent this stream. It is possible to specify <tt>NULL</tt>.\n 609 \n 610 \n 611 @retval true Audio data was written to the buffer.\n 612 @retval false Data is not audio data, streaming has not started, or the library is not initialized.\n 613 \n 614 @date 2012/04/03 - Revised the description of the <SPAN class=\"argument\">outCIDList</SPAN> argument.\n 615 @date 2011/08/31 Initial version.\n 616 \n 617 */\n 618 bool VCT_ReceiveAudio ( void *audio_data, u32 length, u16 outCIDList[] );\n 619 \n 620  /*!\n 621 @brief Sets the audio codec.\n 622 \n 623 @details The codec can be changed even while streaming.\n 624 \n 625 @details The only supported codecs are 4-bit ADPCM and 2-bit ADPCM. Returns <tt>false</tt> when an unsupported audio codec is specified.\n 626 \n 627 @details Use the <tt>@ref VCT_SetSpareCodec</tt> function to change the audio codec for spare packets.\n 628 \n 629 @param[in] codec The changed audio codec type for the sender.\n 630 \n 631 \n 632 @retval true Audio data was written to the buffer.\n 633 @retval false Data is not audio data, streaming has not started, or the library is not initialized.\n 634 @date 2011/08/31 Initial version.\n 635  */\n 636 bool VCT_SetCodec ( VCTCodec codec );\n 637 \n 638  /*!\n 639 @brief Gets the currently configured audio codec.\n 640 \n 641 @details Use the <tt>@ref VCT_GetSpareCodec</tt> function to get the audio codec type for spare packets.\n 642 \n 643 \n 644 \n 645 @retval @ref VCTCodec The audio codec that is currently set for the main packet.\n 646 @date 2011/08/31 Initial version.\n 647  */\n 648 VCTCodec VCT_GetCodec ( void );\n 649 \n 650  /*!\n 651 @brief Determines whether the main packet audio codec type specified by <span class=\"argument\">codec</span> is usable.\n 652 \n 653 @param[in] codec Audio codec type.\n 654 \n 655 @retval true Specifies that the codec can be used.\n 656 @retval false Specifies that the codec cannot be used.\n 657 \n 658 @date 2011/08/31 Initial version.\n 659  */\n 660 bool VCT_IsValidCodec ( VCTCodec codec );\n 661 \n 662  /*!\n 663 @brief Sets the audio frame length.\n 664 \n 665 @details For <span class=\"argument\">frameLength</span>, you must specify a value between <tt>@ref VCT_AUDIO_FRAME_LENGTH_MIN </tt> and <tt>@ref VCT_AUDIO_FRAME_LENGTH_MAX</tt> that is also an integer multiple of 8.\n 666 \n 667 @param[in] frameLength Audio frame length (in milliseconds).\n 668 \n 669 \n 670 @retval true Configuration succeeded.\n 671 @retval false Configuration failed.\n 672 \n 673 @date 2011/08/31 Initial version.\n 674  */\n 675 bool VCT_SetAudioFrameLength ( u32 frameLength );\n 676 \n 677  /*!\n 678 @brief Gets the currently configured audio frame length.\n 679 \n 680 @details Returns the value set in the <span class=\"argument\">frameLength</span> member of the <tt>@ref VCTConfig</tt> structure at time of initialization, or the value set by the <tt>@ref VCT_SetAudioFrameLength</tt> function after initialization.\n 681 \n 682 @details If you call this function before initialization, the recommended value <tt>@ref VCT_AUDIO_FRAME_LENGTH_DEFAULT</tt> is returned.\n 683 \n 684 @retval true Configuration succeeded.\n 685 @retval false Configuration failed.\n 686 \n 687 @date 2011/08/31 Initial version.\n 688  */\n 689 u32 VCT_GetAudioFrameLength ( void );\n 690 \n 691  /*!\n 692 @brief Gets the packet size of audio data.\n 693 \n 694 @details This function returns the data size calculated based on the currently configured audio frame length. You can use the <tt>@ref VCT_GetAudioFrameLength</tt> function to get the currently set audio frame length.\n 695 \n 696 @details If you call this function before initialization, the data size <tt>@ref VCT_AUDIO_DATA_SIZE_DEFAULT</tt> corresponding to the recommended audio frame length <tt>@ref VCT_AUDIO_FRAME_LENGTH_DEFAULT</tt> is returned.\n 697 \n 698 \n 699 @retval u32 Packet size of audio data.\n 700 @date 2011/08/31 Initial version.\n 701  */\n 702 u32 VCT_GetAudioDataSize ( void );\n 703 \n 704  /*!\n 705 @brief Gets the calculated audio scale (square of the average power) of the input audio data.\n 706 \n 707 @details Before using the <tt>@ref VCT_SendAudioEx</tt> function, use this function to get the volume scale value of the input audio data.\n 708 \n 709 @details The <SPAN class=\"argument\">length</SPAN> argument specifies the number of bytes of audio data to input. The audio data must have been sampled at 16 bits/8 kHz.\n 710 \n 711 @param[in] audio Specifies the audio data.\n 712 @param[in] length Specifies the number of bytes of the audio data.\n 713 \n 714 @retval true The received data is VoiceChat data.\n 715 \n 716 @date 2012/04/19 - Corrected the description of the <SPAN class=\"argument\">length</SPAN> argument by changing \"number of samples\" to \"number of bytes.\"\n 717 @date 2011/09/29 - Clarified that the <span class=\"argument\">audio variable</span> is <tt>const</tt>.\n 718 @date 2011/08/31 Initial version.\n 719  */\n 720 u32 VCT_GetAudioScale ( const void *audio, u32 length );\n 721  /*!\n 722 @brief Gets audio streaming information for the party specified by <SPAN class=\"argument\">cid</SPAN>.\n 723 \n 724 @param[in] cid The connection ID of the other party from which to get audio streaming information.\n 725 @param[in] info Pointer to an <tt>@ref VCTAudioInfo</tt> structure.\n 726 \n 727 @date 2011/08/31 Initial version.\n 728  */\n 729 void VCT_GetAudioInfoFromCid ( u16 cid, VCTAudioInfo *info );\n 730 \n 731  /*!\n 732 @cond PRIVATE\n 733 @brief Resets audio streaming information for the terminal that has the specified connection ID.\n 734 \n 735 @details Use the <tt>@ref VCT_ResetAudioInfoAll</tt> function to reset all currently open streams.\n 736 \n 737 @param[in] cid The connection ID of the party for which to reset streaming information.\n 738 \n 739 @date 2011/08/31 Initial version.\n 740  */\n 741 void VCT_ResetAudioInfo ( u16 cid );\n 742 //! @endcond\n 743 \n 744  /*!\n 745 @cond PRIVATE\n 746 @brief Resets the information on all currently open audio streams.\n 747 \n 748 @details Use the <tt>@ref VCT_ResetAudioInfo</tt> function to reset the streaming information for a specific connection ID.\n 749 \n 750 @date 2011/08/31 Initial version.\n 751  */\n 752 void VCT_ResetAudioInfoAll ( void );\n 753 //! @endcond\n 754 \n 755 /*!\n 756 end of name Audio Streaming\n 757  @}\n 758 */\n 759 \n 760 /*!\n 761 @name Noise Skipping\n 762  @{\n 763 */\n 764 \n 765 /*!\n 766 @brief Sets the length of time for which sound is not sent in <tt>@ref VCT_SignalNoiseSkip</tt>.\n 767 \n 768 @param[in] count Specifies the length of time sound is not sent (in milliseconds).\n 769 @date 2012/03/01 Initial version.\n 770  */\n 771 void VCT_SetNoiseSkipTime ( u32 count );\n 772 \n 773  /*!\n 774 @brief Returns the length of time for which sound is not sent in <tt>@ref VCT_SignalNoiseSkip</tt>.\n 775 \n 776 @retval u32 The length of time for which sound is not sent (in milliseconds).\n 777 \n 778 @date 2012/03/01 Initial version.\n 779  */\n 780 u32 VCT_GetNoiseSkipTime ( void );\n 781 \n 782  /*!\n 783 @brief When VAD is enabled and not active, this function makes VAD active on the sound of button presses so that audio is not sent.\n 784 \n 785 @details Setting up this function enables you to prevent the VAD feature from activating and sending audio on the sound of button presses when VAD is enabled but not active.\n 786 By not sending audio for a certain time period after button presses, you can minimize the button pressing sounds received by other players.\n 787 \n 788 @details This function cannot remove button-press sounds while VAD is active and a conversation is being sent.\n 789 \n 790 @details The duration (in milliseconds) to not send sound is specified with <tt>@ref VCT_SetNoiseSkipTime</tt>.\n 791 \n 792 \n 793 @date 2012/05/10 - Revised the description.\n 794 @date 2012/03/15 - Supplemented the description.\n 795 @date 2012/03/01 Initial version.\n 796  */\n 797 \n 798 void VCT_SignalNoiseSkip ( void );\n 799 \n 800 /*!\n 801 end of name Noise Skipping\n 802  @}\n 803 */\n 804 \n 805 /*!\n 806 @name Spare Packets\n 807  @{\n 808 */\n 809 /*===========================================================================*\n 810  *\n 811 * Spare Packet Functions\n 812  *\n 813  *===========================================================================*/\n 814 \n 815  /*!\n 816 @brief This function enables and disables the spare packet feature.\n 817 \n 818 @details The spare packet feature is enabled by default.\n 819 \n 820 @param[in] flag Specify <tt>true</tt> to enable or <tt>false</tt> to disable.\n 821 \n 822 @date 2011/08/31 Initial version.\n 823  */\n 824 void VCT_EnableSparePacket ( bool flag );\n 825 \n 826  /*!\n 827 @brief This function gets whether the spare packet feature is enabled or disabled.\n 828 \n 829 @details The spare packet feature is enabled by default.\n 830 \n 831 @retval true Specifies that the spare packet feature is enabled.\n 832 @retval false Specifies that the spare packet feature is disabled.\n 833 \n 834 @date 2011/08/31 Initial version.\n 835  */\n 836 bool VCT_IsEnableSparePacket ( void );\n 837 \n 838  /*!\n 839 @brief Sets the audio codec for spare packets.\n 840 \n 841 @details By default, spare packets use the 2-bit ADPCM codec.\n 842 \n 843 @details Use the <tt>@ref VCT_SetCodec</tt> function to change the codec for main packets.\n 844 \n 845 @details <b>Note:</b> The only codec type supported for spare packets is 2-bit ADPCM. Accordingly, this function does not need to be called at this time. Returns <tt>false</tt> when an unsupported codec has been specified.\n 846 \n 847 @param[in] spareCodec The spare packet codec type.\n 848 \n 849 @retval true Setting succeeded.\n 850 @retval false Setting failed.\n 851 \n 852 @date 2011/08/31 Initial version.\n 853  */\n 854 bool VCT_SetSpareCodec ( VCTCodec spareCodec );\n 855 \n 856  /*!\n 857 @brief Gets the currently configured audio codec for spare packets.\n 858 \n 859 @details This value is meaningless if the spare packet feature is not used.\n 860 \n 861 @details <b>Note:</b> The only codec type supported for spare packets is 2-bit ADPCM. At the present time, this function always returns <tt>@ref VCT_CODEC_2BIT_ADPCM</tt>.\n 862 \n 863 @retval @ref VCTCodec The currently set codec type for spare packets.\n 864 \n 865 @date 2011/08/31 Initial version.\n 866  */\n 867 VCTCodec VCT_GetSpareCodec ( void );\n 868 \n 869  /*!\n 870 @brief Determines whether you can use the codec type specified by <span class=\"argument\">codec</span> as a spare-packet codec type.\n 871 \n 872 @param[in] codec The codec type.\n 873 \n 874 @retval true Can be used.\n 875 @retval false Cannot be used.\n 876 \n 877 @date 2011/08/31 Initial version.\n 878  */\n 879 bool VCT_IsValidSpareCodec ( VCTCodec codec );\n 880 \n 881 /*!\n 882 end of name Spare Packets\n 883  @}\n 884 */\n 885 /*!\n 886 @name Drop Recovery\n 887  @{\n 888 */\n 889 /*===========================================================================*\n 890  *\n 891 * Drop Recovery\n 892  *\n 893  *===========================================================================*/\n 894 \n 895 /*!\n 896 @cond PRIVATE\n 897 @brief Enables or disables the drop recover feature.\n 898 \n 899 @details The drop recover feature is enabled by default.\n 900 \n 901 @details When the drop recovery feature is enabled, an attempt is made to recover audio data from lost packets.\n 902 \n 903 @details If the spare packet feature is enabled and the spare packet of the next packet is available, the audio data of the current packet is recovered based on the spare packet audio data. This improves audio quality.\n 904 \n 905 @param[in] flag Specify <tt>true</tt> to enable or <tt>false</tt> to disable.\n 906 \n 907 @date 2011/08/31 Initial version.\n 908  */\n 909 void VCT_EnableDropRecover ( bool flag );\n 910 //! @endcond\n 911 \n 912 /*!\n 913 @cond PRIVATE\n 914 @brief Gets whether the drop recover feature is enabled.\n 915 \n 916 @retval true Specifies that the drop recover feature is enabled.\n 917 @retval false Specifies that the drop recover feature is disabled.\n 918 \n 919 @date 2011/08/31 Initial version.\n 920  */\n 921 bool VCT_IsEnableDropRecover ( void );\n 922 //! @endcond\n 923 /*!\n 924 end of name Drop Recovery\n 925  @}\n 926 */\n 927 /*!\n 928 @name VAD\n 929  @{\n 930 */\n 931 /*===========================================================================*\n 932  *\n 933 * VAD Functions\n 934  *\n 935  *===========================================================================*/\n 936 /*!\n 937 @brief Enables or disables the VAD feature.\n 938 \n 939 @details The VAD feature is enabled by default.\n 940 \n 941 @details When VAD is enabled, in addition to evaluating audio inside the <tt>@ref VCT_Main</tt> function, decisions are also made automatically about whether to send packets.\n 942 \n 943 @param[in] flag Specify <tt>true</tt> to enable or <tt>false</tt> to disable.\n 944 \n 945 @date 2011/08/31 Initial version.\n 946  */\n 947 void VCT_EnableVAD ( bool flag );\n 948 \n 949 /*!\n 950 @brief Gets whether the VAD feature is enabled.\n 951 \n 952 @retval true Specifies that the VAD feature is enabled.\n 953 @retval false Specifies that the VAD feature is disabled.\n 954 \n 955 @date 2011/08/31 Initial version.\n 956  */\n 957 bool VCT_IsEnableVAD ( void );\n 958 \n 959 /*!\n 960 @brief VAD Gets the audio detection results from the VAD algorithm.\n 961 \n 962 @details Returns <tt>true</tt> while audio is detected in the frame (speech frame) and <tt>false</tt> while it is not (silent frame).\n 963 \n 964 @details Always returns <tt>false</tt> while the VAD feature is disabled, regardless of the presence of speech.\n 965 \n 966 @retval true Specifies that audio is present.\n 967 @retval false Specifies that no audio is present.\n 968 \n 969 @date 2011/08/31 Initial version.\n 970  */\n 971 bool VCT_GetVADActivity ( void );\n 972 \n 973 /*!\n 974 @cond PRIVATE\n 975 @brief Gets the average power of audio data in the current audio frame.\n 976 \n 977 @details The VAD algorithm detects audio based on the size of this value. This value is equal to the average power of the entire audio data sample (the square root of the audio data volume scale value used by the <tt>@ref VCT_GetAudioScale</tt> and <tt>@ref VCT_SetVADClampGain</tt> functions) divided by a normalizing factor (256).\n 978 \n 979 @retval u16 Average power of the audio data in the current audio frame.\n 980 \n 981 @date 2011/08/31 Initial version.\n 982  */\n 983 u16 VCT_GetVADPower ( void );\n 984 //! @endcond\n 985 \n 986 /*!\n 987 @brief Resets the internal VAD status.\n 988 \n 989 @details Call this function after making changes to the microphone gain or similar settings.\n 990 \n 991 \n 992 @date 2011/08/31 Initial version.\n 993  */\n 994 void VCT_ResetVAD ( void );\n 995 \n 996 /*!\n 997 @brief Sets the speech frame detection threshold.\n 998 \n 999 @details When the previous audio frame is recognized as a silent frame, this threshold value is used to determine whether the current audio frame contains speech.\n 1000 \n 1001 @details A frame is recognized as containing speech when the following condition is met, where Ts is the threshold value, Ec is the average speech power of the audio data in the current frame, and En is the average speech power of the audio data in the four previous frames.\n 1002 \n 1003 @details Ec > En * Ts / 100\n 1004 \n 1005 @details The value argument takes the threshold (Ts). The default value is 350. In this case, the threshold of the power difference between <tt>En</tt> and <tt>Ec</tt> is equivalent to <tt>20 * log (350 / 100) = 10.9 dB</tt>.\n 1006 \n 1007 @param[in] value Specifies the speech frame detection threshold.\n 1008 \n 1009 @date 2011/08/31 Initial version.\n 1010  */\n 1011 void VCT_SetVADActiveGain ( u16 value );\n 1012 \n 1013 /*!\n 1014 @brief Gets the current speech frame detection threshold.\n 1015 \n 1016 @retval u16 Threshold for detecting a speech frame.\n 1017 \n 1018 @date 2011/08/31 Initial version.\n 1019  */\n 1020 u16 VCT_GetVADActiveGain ( void );\n 1021 \n 1022 /*!\n 1023 @brief Sets the silent frame detection threshold.\n 1024 \n 1025 @details When the previous audio frame is recognized as a speech frame, this threshold value is used to determine whether the current audio frame is silent.\n 1026 \n 1027 @details A frame is recognized as being a silent frame when the following condition is met, where Tn is the threshold value, Ec is the average speech power of the audio data in the most-recent four frames, and En is the average speech power of the audio data in the four frames prior to the last audio frame that was determined to be a silent frame.\n 1028 \n 1029 @details Ec < En * Tn / 100\n 1030 \n 1031 @details However, the sending of audio frames actually stops when silence is determined to continue for the consecutive number of frames specified by the <tt>@ref VCT_SetVADReleaseTime</tt> function.\n 1032 \n 1033 @details The value argument takes the threshold (Tn). The default value is 280. In this case, the threshold of the power difference between <tt>En</tt> and <tt>Ec</tt> is equivalent to <tt>20 * log (280 / 100) = 8.94 dB</tt>.\n 1034 \n 1035 @param[in] value Specifies the silent frame detection threshold.\n 1036 \n 1037 @date 2011/08/31 Initial version.\n 1038  */\n 1039 void VCT_SetVADInactiveGain ( u16 value );\n 1040 /*!\n 1041 @brief Gets the current silent frame detection threshold.\n 1042 \n 1043 @retval u16 Threshold for detecting a silent frame.\n 1044 \n 1045 @date 2011/08/31 Initial version.\n 1046  */\n 1047 u16 VCT_GetVADInactiveGain ( void );\n 1048 \n 1049 /*!\n 1050 @brief Sets the time that must elapse after silence is detected before packet transmission is stopped.\n 1051 \n 1052 @details To prevent VAD from detecting silence in the middle of a conversation because, for example, the user takes a breath, set the release time to at least 500 ms.\n 1053 \n 1054 @details For <SPAN class=\"argument\">count</SPAN>, specify the time (in packets) to wait after VAD has detected silence before packet transmission is halted. The default is 5 packets (<tt>144 * 5 = 720 ms</tt>).\n 1055 \n 1056 @param[in] count Release time (in number of packets).\n 1057 \n 1058 @date 2011/08/31 Initial version.\n 1059  */\n 1060 void VCT_SetVADReleaseTime ( u32 count );\n 1061 \n 1062 /*!\n 1063 @brief Gets the time that must elapse after silence is detected before packet transmission is stopped.\n 1064 \n 1065 @retval u32 Release time (in number of packets).\n 1066 \n 1067 @date 2011/08/31 Initial version.\n 1068  */\n 1069 u32 VCT_GetVADReleaseTime ( void );\n 1070 \n 1071 /*!\n 1072 @brief Sets the volume threshold as a volume scale value (the square of the average power) for unconditionally determining silence.\n 1073 \n 1074 @details <span class=\"argument\">value</span> takes a volume scale value in a range from <tt>0</tt> through <tt>0x3FFFFFFF</tt>. Any audio frame with a volume scale value below this specified threshold is determined to be a silent frame.\n 1075 \n 1076 @details Uses the volume scale value for audio data obtained by the <tt>@ref VCT_GetAudioScale</tt> function.\n 1077 \n 1078 @details The default value is 49.\n 1079 \n 1080 @param[in] value The volume threshold at which a frame is unconditionally determined to be silent.\n 1081 @date 2011/08/31 Initial version.\n 1082  */\n 1083 void VCT_SetVADClampGain ( u32 value );\n 1084 \n 1085 /*!\n 1086 @brief Gets the volume threshold as a volume scale value for unconditionally determining silence.\n 1087 \n 1088 @details The volume scale value is specified in the range from <tt>0</tt> through <tt>0x3FFFFFFF</tt>.\n 1089 \n 1090 @retval u32 The volume threshold at which a frame is unconditionally determined to be silent.\n 1091 \n 1092 @date 2011/08/31 Initial version.\n 1093  */\n 1094 u32 VCT_GetVADClampGain ( void );\n 1095 \n 1096 /*!\n 1097 end of name VAD\n 1098  @}\n 1099 */\n 1100 \n 1101 /*!\n 1102 @name HPF\n 1103  @{\n 1104 */\n 1105 /*===========================================================================*\n 1106  *\n 1107 * HPF Functions\n 1108  *\n 1109  *===========================================================================*/\n 1110 /*!\n 1111 @cond PRIVATE\n 1112 @brief Enables or disables the high-pass filter.\n 1113 \n 1114 @details By default, the high-pass filter is disabled.\n 1115 \n 1116 @details When this feature is enabled, the high-pass filter is applied inside the <tt>@ref VCT_Main</tt> function to eliminate low-range noise from the audio being sent.\n 1117 \n 1118 @param[in] flag Specify <tt>true</tt> to enable or <tt>false</tt> to disable.\n 1119 \n 1120 @date 2011/08/31 Initial version.\n 1121  */\n 1122 void VCT_EnableHPF ( bool flag );\n 1123 //! @endcond\n 1124 \n 1125 /*!\n 1126 @cond PRIVATE\n 1127 @brief Gets whether the high-pass filter is enabled.\n 1128 \n 1129 @retval true The high-pass filter feature is enabled.\n 1130 @retval false The high-pass filter feature is disabled.\n 1131 \n 1132 @date 2011/08/31 Initial version.\n 1133  */\n 1134 bool VCT_IsEnableHPF ( void );\n 1135 //! @endcond\n 1136 /*!\n 1137 end of name HPF\n 1138  @}\n 1139 */\n 1140 \n 1141 /*!\n 1142 @name BPF\n 1143  @{\n 1144 */\n 1145 /*===========================================================================*\n 1146  *\n 1147 * BPF Functions\n 1148  *\n 1149  *===========================================================================*/\n 1150 \n 1151 /*!\n 1152 @cond PRIVATE\n 1153 @brief Enables or disables the biquad filter.\n 1154 \n 1155 @details By default, the biquad filter is disabled.\n 1156 \n 1157 @details When this feature is enabled, the biquad filter is applied inside the <tt>@ref VCT_Main</tt> function to eliminate noise outside of the range of speech from the audio being sent.\n 1158 \n 1159 \n 1160 @param[in] flag Specify <tt>true</tt> to enable or <tt>false</tt> to disable.\n 1161 \n 1162 @date 2011/12/09 Initial version.\n 1163  */\n 1164 void VCT_EnableBPF ( bool flag );\n 1165 //! @endcond\n 1166 \n 1167 /*!\n 1168 @cond PRIVATE\n 1169 @brief Gets whether the biquad filter is enabled.\n 1170 \n 1171 @retval true The biquad filter is enabled.\n 1172 @retval false The biquad filter is disabled.\n 1173 \n 1174 @date 2011/12/09 Initial version.\n 1175  */\n 1176 bool VCT_IsEnableBPF ( void );\n 1177 //! @endcond\n 1178 \n 1179 /*!\n 1180 end of name HPF\n 1181  @}\n 1182 */\n 1183 \n 1184 \n 1185 #ifdef NN_VCT_TARGET_CTR\n 1186 /*!\n 1187 @name Echo Canceler\n 1188  @{\n 1189 */\n 1190 /*===========================================================================*\n 1191  *\n 1192 * Echo-Canceler Functions\n 1193  *\n 1194  *===========================================================================*/\n 1195 /*!\n 1196 @cond PRIVATE\n 1197 @brief Enables or disables the echo canceler.\n 1198 \n 1199 @details The echo canceler feature is enabled by default.\n 1200 \n 1201 @details When this feature is enabled, echo cancellation is performed inside the <tt>@ref VCT_SendAudioEx</tt> function.\n 1202 \n 1203 @param[in] flag Specify <tt>true</tt> to enable or <tt>false</tt> to disable.\n 1204 \n 1205 @date 2013/06/11 Changed the default from disabled to enabled.\n 1206 @date 2011/08/31 Initial version.\n 1207  */\n 1208 void VCT_EnableEchoCancel ( bool flag );\n 1209 //! @endcond\n 1210 \n 1211 /*!\n 1212 @cond PRIVATE\n 1213 @brief Gets whether the echo canceler is enabled.\n 1214 \n 1215 @retval true The echo canceler is enabled.\n 1216 @retval false The echo canceler is disabled.\n 1217 @date 2011/08/31 Initial version.\n 1218  */\n 1219 bool VCT_IsEnableEchoCancel ( void );\n 1220 //! @endcond\n 1221 \n 1222 /*!\n 1223 @brief Supplies reference data for the echo canceler.\n 1224 \n 1225 @details Call the <tt>nn::snd::GetMixedBusData</tt> function at every sound DSP interrupt (every 5 ms), and pass the 5 ms of 16 bit/32 kHz/stereo data obtained by that function to the <span class=\"argument\">buffer</span> of this function.\n 1226 \n 1227 @details This function does nothing if <SPAN class=\"argument\">size</SPAN> is not the correct size for 5 milliseconds of 16-bit/32-kHz stereo data.\n 1228 \n 1229 @param[in] buffer Reference data for the echo canceler.\n 1230 @param[in] size The size of the reference data for the echo canceler.\n 1231 \n 1232 \n 1233 @date 2011/09/29 - Clarified that the <span class=\"argument\">buffer</span> variable is <tt>const</tt>.\n 1234 @date 2011/08/31 Initial version.\n 1235  */\n 1236 \n 1237 void VCT_HandleReference ( const u8 *buffer, u32 size );\n 1238 /*!\n 1239 end of name Echo Canceller\n 1240  @}\n 1241 */\n 1242 #endif // NN_VCT_TARGET_CTR\n 1243 \n 1244 #ifdef __cplusplus\n 1245 }\n 1246 #endif\n 1247 \n 1248 #endif /* VCT_VOICECHAT_H_ */\n 1249 /*!!!! EOF !!!!*/\n",1]
];
for (var x = 0; x < Search.additionalData.length; x++) Search.indexData.push(Search.additionalData[x]);
